import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * Describes available methods of collision avoidance of category series' markers.
 */
export declare enum CategorySeriesMarkerCollisionAvoidance {
    /**
     * Collision avoidance is disabled.
     */
    None = 0,
    /**
     * Items colliding with other items will be hidden from view.
     */
    Omit = 1
}
/**
 * @hidden
 */
export declare let CategorySeriesMarkerCollisionAvoidance_$type: Type;
