import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * An enum representing the available Y axis types in the Financial Chart.
 */
export declare enum FinancialChartYAxisMode {
    /**
     * A linear or logarithmic numeric scale.
     */
    Numeric = 0,
    /**
     * A numeric scale where all values are scaled proportionally to a reference value.
     */
    PercentChange = 1
}
/**
 * @hidden
 */
export declare let FinancialChartYAxisMode_$type: Type;
