import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export interface IAngleScaler {
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
}
/**
 * @hidden
 */
export declare let IAngleScaler_$type: Type;
