import { Path } from "igniteui-angular-core/ES2015/Path";
import { IList$1, Type } from "igniteui-angular-core/ES2015/type";
import { ZoomSliderOrientation } from "./ZoomSliderOrientation";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
/**
 * @hidden
 */
export interface ITrackThumbVisual {
    readonly thumbBox: Path;
    readonly thumbRidges: Path;
    readonly allPaths: IList$1<Path>;
    width: number;
    height: number;
    translateX: number;
    translateY: number;
    orientation: ZoomSliderOrientation;
    getTrackThumbDefaultWidth(): number;
    getTrackThumbDefaultHeight(): number;
    getThumbBoxDefaultStroke(): Brush;
    getThumbBoxDefaultStrokeThickness(): number;
    getThumbBoxDefaultBrush(): Brush;
    getThumbRidgesDefaultStroke(): Brush;
}
/**
 * @hidden
 */
export declare let ITrackThumbVisual_$type: Type;
