import { LegendBase } from "./LegendBase";
import { IChartItemLegend } from "igniteui-angular-core/ES2015/IChartItemLegend";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { LegendBaseView } from "./LegendBaseView";
import { Type } from "igniteui-angular-core/ES2015/type";
import { UIElement } from "igniteui-angular-core/ES2015/UIElement";
import { ILegendSeries } from "igniteui-angular-core/ES2015/ILegendSeries";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { ILegendContext } from "igniteui-angular-core/ES2015/ILegendContext";
import { LegendVisualData } from "./LegendVisualData";
/**
 * @hidden
 */
export declare class ItemLegend extends LegendBase implements IChartItemLegend {
    static $t: Type;
    aj(): LegendBaseView;
    a8(a: LegendBaseView): void;
    bb: ItemLegendView;
    constructor();
    addChildInOrder(a: UIElement, b: ILegendSeries): void;
    protected get_isItemwise(): boolean;
    createItemwiseLegendItems(a: List$1<UIElement>, b: ILegendSeries): void;
    a0(a: List$1<UIElement>, b: ILegendSeries): void;
    createLegendItemsInsert(a: List$1<UIElement>, b: ILegendSeries): void;
    bf(a: List$1<UIElement>, b: ILegendSeries): void;
    renderItemwiseContent(a: ILegendSeries): void;
    bg(a: ILegendSeries): void;
    be(a: ILegendSeries): number;
    private bd;
    bc: IFastItemColumn$1<number>;
}
/**
 * @hidden
 */
export declare class ItemLegendView extends LegendBaseView {
    static $t: Type;
    constructor(a: ItemLegend);
    ao: ItemLegend;
    ak(): void;
    protected get_j(): boolean;
    ap(a: ILegendContext): boolean;
    f(): LegendVisualData;
}
