import { LegendBase } from "./LegendBase";
import { IChartScaleLegend } from "igniteui-angular-core/ES2015/IChartScaleLegend";
import { UIElement } from "igniteui-angular-core/ES2015/UIElement";
import { TextBlock } from "igniteui-angular-core/ES2015/TextBlock";
import { IScaleLegendSeries } from "igniteui-angular-core/ES2015/IScaleLegendSeries";
import { LegendBaseView } from "./LegendBaseView";
import { Type } from "igniteui-angular-core/ES2015/type";
import { Color } from "igniteui-angular-core/ES2015/Color";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { Shape } from "igniteui-angular-core/ES2015/Shape";
import { GradientData } from "./GradientData";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
import { Size } from "igniteui-angular-core/ES2015/Size";
/**
 * @hidden
 */
export declare class ScaleLegend extends LegendBase implements IChartScaleLegend {
    static $t: Type;
    aj(): LegendBaseView;
    a8(a: LegendBaseView): void;
    bd: ScaleLegendView;
    readonly legendScaleElement: UIElement;
    readonly minText: TextBlock;
    readonly maxText: TextBlock;
    constructor();
    bf: number;
    be: number;
    private bb;
    bc: IScaleLegendSeries;
    bi(): void;
    restoreOriginalState(): void;
    private bl;
    bg(a: IScaleLegendSeries): void;
    initializeLegend(a: IScaleLegendSeries): void;
    protected get_isScale(): boolean;
    bh(): void;
}
/**
 * @hidden
 */
export declare class ScaleLegendView extends LegendBaseView {
    static $t: Type;
    constructor(a: ScaleLegend);
    ap: ScaleLegend;
    ba: Shape;
    a6: TextBlock;
    a5: TextBlock;
    a2(): void;
    z(): void;
    a9(): Color;
    aw(): any;
    ay(a: any, b: Color, c: number): void;
    a3(a: Shape, b: boolean, c: any): void;
    protected ao: GradientData;
    protected aq: RenderingContext;
    protected bb: Size;
    ai(a: any): void;
    protected ar: boolean;
    protected az(): void;
    a4(): void;
    private a1;
    au(a: any): number;
    at(a: any): number;
    protected as: number;
    protected a8: Brush;
    private a0;
    a7: Brush;
    al(): void;
}
