import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { StyleSelector } from "./StyleSelector";
import { Style } from "igniteui-angular-core/ES2015/Style";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { SeriesView } from "./SeriesView";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { DataContext } from "igniteui-angular-core/ES2015/DataContext";
import { FrameworkElement } from "igniteui-angular-core/ES2015/FrameworkElement";
import { PathGeometry } from "igniteui-angular-core/ES2015/PathGeometry";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { PointCollection } from "igniteui-angular-core/ES2015/PointCollection";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
/**
 * @hidden
 */
export declare class ScatterPolylineSeries extends ShapeSeriesBase {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    iu(a: SeriesView): void;
    protected na: ScatterPolylineSeriesView;
    protected get_mf(): boolean;
    nb: StyleSelector;
    ng: Style;
    protected iz(a: any, b: string, c: any, d: any): void;
    protected mz(a: SeriesView): void;
    ar(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterPolylineSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: ScatterPolylineSeries);
    protected cu(a: number, b: List$1<PointCollection>): PathGeometry;
    protected cc(a: FrameworkElement, b: any): void;
    protected ca(a: FrameworkElement, b: PathGeometry): void;
    protected bb(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    b2(a: Rect): boolean;
    getDefaultTooltipTemplate(): string;
}
