import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { PointCollection } from "igniteui-angular-core/ES2015/PointCollection";
import { UnknownValuePlotting } from "igniteui-angular-core/ES2015/UnknownValuePlotting";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Clipper } from "igniteui-angular-core/ES2015/Clipper";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
/**
 * @hidden
 */
export declare class SplineAreaSeries extends SplineSeriesBase {
    static $t: Type;
    protected bf(): SeriesView;
    protected ng(): CategoryTransitionInMode;
    iu(a: SeriesView): void;
    qs: SplineAreaSeriesView;
    constructor();
    qr: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    hv(a: boolean, b: SeriesView): void;
    dh(a: Point, b: boolean): boolean;
    oo(a: CategoryFrame, b: CategorySeriesView): void;
    readonly useHighMarkerFidelity: boolean;
}
/**
 * @hidden
 */
export declare class SplineAreaSeriesView extends SplineSeriesBaseView {
    static $t: Type;
    protected c7: SplineAreaSeries;
    constructor(a: SplineAreaSeries);
    ap(): void;
    private dh;
    private dl;
    private dj;
    private dm;
    readonly df: Path;
    readonly dg: Path;
    readonly di: Path;
    readonly dk: Path;
    c8(): void;
    c9(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    da(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private db;
    private dd;
    private dc;
    private de;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
}
