/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { AnnotationFactoryManager } from './AnnotationFactoryManager';
import { IgxCrosshairLayerModule } from './igx-crosshair-layer-module';
import { IgxCategoryToolTipLayerModule } from './igx-category-tool-tip-layer-module';
import { IgxItemToolTipLayerModule } from './igx-item-tool-tip-layer-module';
import { IgxCategoryItemHighlightLayerModule } from './igx-category-item-highlight-layer-module';
import { IgxCategoryHighlightLayerModule } from './igx-category-highlight-layer-module';
import { IgxFinalValueLayerModule } from './igx-final-value-layer-module';
import { IgxCalloutLayerModule } from './igx-callout-layer-module';
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
let IgxDataChartAnnotationModule = class IgxDataChartAnnotationModule {
    constructor() {
        TypeRegistrar.register('AnnotationFactoryManager', AnnotationFactoryManager.$type);
    }
};
IgxDataChartAnnotationModule = tslib_1.__decorate([
    NgModule({
        declarations: [],
        exports: [IgxCrosshairLayerModule,
            IgxCategoryToolTipLayerModule,
            IgxItemToolTipLayerModule,
            IgxCategoryItemHighlightLayerModule,
            IgxCategoryHighlightLayerModule,
            IgxFinalValueLayerModule,
            IgxCalloutLayerModule
        ],
        imports: [CommonModule, IgxCrosshairLayerModule,
            IgxCategoryToolTipLayerModule,
            IgxItemToolTipLayerModule,
            IgxCategoryItemHighlightLayerModule,
            IgxCategoryHighlightLayerModule,
            IgxFinalValueLayerModule,
            IgxCalloutLayerModule
        ],
        entryComponents: []
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxDataChartAnnotationModule);
export { IgxDataChartAnnotationModule };
//# sourceMappingURL=igx-data-chart-annotation-module.js.map