import { IgCollection } from "igniteui-angular-core/ES2015/IgCollection";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES2015/SyncableObservableCollection$2";
import { FinancialOverlayType_$type } from './FinancialOverlayType';
import { ensureEnum } from "igniteui-angular-core/ES2015/componentUtil";
export class FinancialOverlayTypeCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(FinancialOverlayType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(FinancialOverlayType_$type, FinancialOverlayType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-financial-overlay-type-collection.js.map