import { SelectedItemsChangedEventArgs } from "./igx-selected-items-changed-event-args";
import { ensureBool } from "igniteui-angular-core/ES2015/componentUtil";
/**
 * Provides data for the SelectedItemsChanging event.
*/
export class SelectedItemsChangingEventArgs extends SelectedItemsChangedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Set this to true in order to stop the SelectedItems collection from changing.
    */
    get cancel() {
        return this.i.cancel;
    }
    set cancel(v) {
        this.i.cancel = ensureBool(v);
    }
}
//# sourceMappingURL=igx-selected-items-changing-event-args.js.map