import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { IgxTimeAxisLabelFormatComponent } from './igx-time-axis-label-format-component';
import { TimeAxisLabelFormat } from './TimeAxisLabelFormat';
import { TimeAxisLabelFormatCollection as TimeAxisLabelFormatCollection_internal } from './TimeAxisLabelFormatCollection';
import { TimeAxisLabelFormatCollection } from './igx-time-axis-label-format-collection';
let IgxTimeAxisLabelFormatModule = class IgxTimeAxisLabelFormatModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeAxisLabelFormatComponent", IgxTimeAxisLabelFormatComponent);
        TypeRegistrar.registerCons("IgxTimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection);
        TypeRegistrar.register("TimeAxisLabelFormat", TimeAxisLabelFormat.$type);
        TypeRegistrar.register("TimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection_internal.$type);
    }
};
IgxTimeAxisLabelFormatModule = tslib_1.__decorate([
    NgModule({
        imports: [
            CommonModule,
        ],
        declarations: [
            IgxTimeAxisLabelFormatComponent
        ],
        exports: [
            IgxTimeAxisLabelFormatComponent
        ],
        entryComponents: [
            IgxTimeAxisLabelFormatComponent
        ]
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTimeAxisLabelFormatModule);
export { IgxTimeAxisLabelFormatModule };
//# sourceMappingURL=igx-time-axis-label-format-module.js.map