import { DependencyObject } from "igniteui-angular-core/ES5/DependencyObject";
import { INotifyPropertyChanged, PropertyChangedEventArgs, Type } from "igniteui-angular-core/ES5/type";
import { IAxisAnnotation } from "./IAxisAnnotation";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
/**
 * @hidden
 */
export declare class AxisAnnotation extends DependencyObject implements INotifyPropertyChanged, IAxisAnnotation {
    static $t: Type;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected k: boolean;
    resetCachedExtent(): void;
    checkForExtentReset(a: () => void): void;
    value: any;
    text: string;
    private aa;
    private z;
    resolveLabelValue(): string;
    private _formatLabel;
    formatLabel: (item: any) => string;
    textColor: Brush;
    background: Brush;
    outline: Brush;
    strokeThickness: number;
    j: boolean;
    backgroundPadding: Thickness;
    backgroundPaddingLeft: number;
    backgroundPaddingTop: number;
    backgroundPaddingRight: number;
    backgroundPaddingBottom: number;
    static $$p: string[];
}
