import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
/**
 * @hidden
 */
export declare class BollingerBandWidthIndicator extends StrategyBasedIndicator {
    static $t: Type;
    protected get_qc(): IndicatorCalculationStrategy;
    protected readonly qc: IndicatorCalculationStrategy;
    protected get_qp(): Type;
    protected readonly qp: Type;
    qy: number;
    static readonly q1: DependencyProperty;
    protected qi(): number;
    qx: number;
    static readonly q0: DependencyProperty;
    protected qg(): number;
}
