import { DependencyObject } from "igniteui-angular-core/ES5/DependencyObject";
import { INotifyPropertyChanged, Base, PropertyChangedEventArgs, Type } from "igniteui-angular-core/ES5/type";
import { Series } from "./Series";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
import { LabelCollisionInfo } from "igniteui-angular-core/ES5/LabelCollisionInfo";
/**
 * @hidden
 */
export declare class CalloutAnnotation extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    k: CalloutAnnotationWrapper;
    xValue: any;
    yValue: any;
    text: string;
    key: any;
    content: any;
    series: Series;
    private an;
    private am;
    private _formatLabel;
    formatLabel: (item: any) => string;
    textColor: Brush;
    background: Brush;
    outline: Brush;
    leaderBrush: Brush;
    strokeThickness: number;
    m: boolean;
    backgroundPadding: Thickness;
    backgroundPaddingLeft: number;
    backgroundPaddingTop: number;
    backgroundPaddingRight: number;
    backgroundPaddingBottom: number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutAnnotationWrapper extends Base {
    static $t: Type;
    private a;
    b: CalloutAnnotation;
    c: LabelCollisionInfo;
    equals(a: any): boolean;
    getHashCode(): number;
}
