import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ConsolidatedItemsPosition } from "./ConsolidatedItemsPosition";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { CategoryFrame } from "./CategoryFrame";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { Rectangle } from "igniteui-angular-core/ES5/Rectangle";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
/**
 * @hidden
 */
export declare class ColumnSeries extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected bf(): SeriesView;
    qh: ColumnSeriesView;
    iu(a: SeriesView): void;
    protected ng(): CategoryTransitionInMode;
    constructor();
    ql: number;
    qm: number;
    protected get_nv(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private qn;
    lu(a: Point): Rect;
    dh(a: Point, b: boolean): boolean;
    hv(a: boolean, b: SeriesView): void;
    eg(): number;
    oo(a: CategoryFrame, b: CategorySeriesView): void;
    private qi;
    qj: ConsolidatedItemsPosition;
    private qk;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ColumnSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    ap(): void;
    protected c6: ColumnSeries;
    constructor(a: ColumnSeries);
    de(): Rectangle;
    protected c8: List$1<Rectangle>;
    c9(a: Rectangle): void;
    db(a: Rectangle): void;
    da(a: Rectangle): void;
    dc(a: Rectangle, b: number, c: number): void;
    protected z(a: number): any;
    private dd;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    c7: Pool$1<Rectangle>;
    ai(a: any): void;
}
