import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Determines the item returned in hit-testing when mousing over an object which represents several consolidated items.
 */
export declare enum ConsolidatedItemHitTestBehavior {
    /**
     * Returns the item based on the X-location only.  Will return one of the consolidated items.
     */
    Basic = 0,
    /**
     * Returns the item with the nearest Y-location out of all the items with a matching X-location.
     */
    NearestY = 1
}
/**
 * @hidden
 */
export declare let ConsolidatedItemHitTestBehavior_$type: Type;
