/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core/ES5/type";
/**
 * An enum representing the available display modes of crosshairs lines in the chart.
 */
export var CrosshairsDisplayMode;
(function (CrosshairsDisplayMode) {
    /**
     * Display default number of crosshair lines in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Default"] = 0] = "Default";
    /**
     * Display no crosshair lines in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["None"] = 1] = "None";
    /**
     * Display horizontal line of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Horizontal"] = 2] = "Horizontal";
    /**
     * Display vertical line of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Vertical"] = 3] = "Vertical";
    /**
     * Display both horizontal and vertical lines of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Both"] = 4] = "Both";
})(CrosshairsDisplayMode || (CrosshairsDisplayMode = {}));
/**
 * @hidden
 */
export var CrosshairsDisplayMode_$type = markEnum('CrosshairsDisplayMode', 'Default,0|None,1|Horizontal,2|Vertical,3|Both,4');
//# sourceMappingURL=CrosshairsDisplayMode.js.map