import { Base, IList$1, Type } from "igniteui-angular-core/ES5/type";
import { ITrackRangeVisual } from "./ITrackRangeVisual";
import { ZoomSliderOrientation } from "./ZoomSliderOrientation";
import { Path } from "igniteui-angular-core/ES5/Path";
import { Brush } from "igniteui-angular-core/ES5/Brush";
/**
 * @hidden
 */
export declare class DefaultTrackRangeVisual extends Base implements ITrackRangeVisual {
    static $t: Type;
    constructor();
    getThumbBoxDefaultStroke(): Brush;
    getThumbBoxDefaultStrokeThickness(): number;
    getThumbBoxDefaultBrush(): Brush;
    getThumbRidgesDefaultStroke(): Brush;
    private _translateX;
    translateX: number;
    private _translateY;
    translateY: number;
    private e;
    private d;
    private a;
    orientation: ZoomSliderOrientation;
    private c;
    width: number;
    private f;
    private b;
    height: number;
    private _thumbBox;
    thumbBox: Path;
    private _thumbRidges;
    thumbRidges: Path;
    private _allPaths;
    allPaths: IList$1<Path>;
}
