/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { ErrorBarSettingsBase } from "./ErrorBarSettingsBase";
import { EnableErrorBars_$type } from "./EnableErrorBars";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { ErrorBarCalculatorReference_$type } from "igniteui-angular-core/ES5/ErrorBarCalculatorReference";
import { IErrorBarCalculator_$type } from "igniteui-angular-core/ES5/IErrorBarCalculator";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Style } from "igniteui-angular-core/ES5/Style";
import { Type, runOn, delegateCombine, enumGetBox, typeCast, delegateRemove, markType } from "igniteui-angular-core/ES5/type";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
/**
 * @hidden
 */
var ScatterErrorBarSettings = /** @class */ (function (_super) {
    tslib_1.__extends(ScatterErrorBarSettings, _super);
    function ScatterErrorBarSettings() {
        var _this = _super.call(this) || this;
        _this.q = null;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, runOn(_this, _this.ap));
        return _this;
    }
    Object.defineProperty(ScatterErrorBarSettings.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
        },
        enumerable: true,
        configurable: true
    });
    ScatterErrorBarSettings.prototype.ap = function (a, b) {
        switch (b.propertyName) {
            case ScatterErrorBarSettings.$$p[2]:
            case ScatterErrorBarSettings.$$p[8]:
                var c = typeCast(IErrorBarCalculator_$type, b.oldValue);
                if (c != null) {
                    c.changed = delegateRemove(c.changed, runOn(this, this.ao));
                }
                if (this.r != null) {
                    this.r.jd(false);
                    if (this.r.bs != null) {
                        this.r.ik();
                    }
                }
                var d = typeCast(IErrorBarCalculator_$type, b.newValue);
                if (d != null) {
                    d.changed = delegateCombine(d.changed, runOn(this, this.ao));
                }
                break;
            case ScatterErrorBarSettings.$$p[0]:
            case ScatterErrorBarSettings.$$p[1]:
            case ScatterErrorBarSettings.$$p[3]:
            case ScatterErrorBarSettings.$$p[4]:
            case ScatterErrorBarSettings.$$p[5]:
            case ScatterErrorBarSettings.$$p[6]:
            case ScatterErrorBarSettings.$$p[7]:
            case ScatterErrorBarSettings.$$p[9]:
            case ScatterErrorBarSettings.$$p[10]:
            case ScatterErrorBarSettings.$$p[11]:
            case ScatterErrorBarSettings.$$p[12]:
            case ScatterErrorBarSettings.$$p[13]:
                if (this.r != null) {
                    this.r.jd(false);
                    if (this.r.bs != null) {
                        this.r.ik();
                    }
                }
                break;
        }
    };
    ScatterErrorBarSettings.prototype.ao = function (a, b) {
        var c = typeCast(IErrorBarCalculator_$type, a);
        if (c != null) {
            c.changed = delegateRemove(c.changed, runOn(this, this.ao));
            if (this.r != null) {
                this.r.jd(false);
            }
            c.changed = delegateCombine(c.changed, runOn(this, this.ao));
        }
    };
    ScatterErrorBarSettings.$t = markType(ScatterErrorBarSettings, 'ScatterErrorBarSettings', ErrorBarSettingsBase.$);
    return ScatterErrorBarSettings;
}(ErrorBarSettingsBase));
export { ScatterErrorBarSettings };
Type.dep(DependencyProperty, PropertyMetadata, ScatterErrorBarSettings, 'l', ['EnableErrorBarsHorizontal:o:aq', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'EnableErrorBarsVertical:p:ar', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'HorizontalCalculator:u:as', [IErrorBarCalculator_$type, null], 'HorizontalCalculatorReference:s:at', [ErrorBarCalculatorReference_$type, enumGetBox(ErrorBarCalculatorReference_$type, 0)], 'HorizontalErrorBarCapLength:y:au', [1, 6], 'HorizontalErrorBarStyle:a6:av', [Style.$, null], 'HorizontalStroke:a4:aw', [Brush.$, null], 'HorizontalStrokeThickness:w:ax', [1, 1], 'VerticalCalculator:v:ay', [IErrorBarCalculator_$type, null], 'VerticalCalculatorReference:t:az', [ErrorBarCalculatorReference_$type, enumGetBox(ErrorBarCalculatorReference_$type, 1)], 'VerticalErrorBarCapLength:z:a0', [1, 6], 'VerticalErrorBarStyle:a7:a1', [Style.$, null], 'VerticalStroke:a5:a2', [Brush.$, null], 'VerticalStrokeThickness:x:a3', [1, 1]]);
//# sourceMappingURL=ScatterErrorBarSettings.js.map