import { Base, Type } from "igniteui-angular-core/ES5/type";
import { RectData } from "igniteui-angular-core/ES5/RectData";
import { PrimitiveVisualDataList } from "igniteui-angular-core/ES5/PrimitiveVisualDataList";
import { PointerTooltipVisualDataList } from "./PointerTooltipVisualDataList";
import { MarkerVisualDataList } from "./MarkerVisualDataList";
import { CalloutVisualDataList } from "./CalloutVisualDataList";
/**
 * @hidden
 */
export declare class SeriesVisualData extends Base {
    static $t: Type;
    constructor();
    private _name;
    name: string;
    private _type;
    type: string;
    private _viewport;
    viewport: RectData;
    private _opacity;
    opacity: number;
    private _shapes;
    shapes: PrimitiveVisualDataList;
    private _pointerTooltips;
    pointerTooltips: PointerTooltipVisualDataList;
    private _markerShapes;
    markerShapes: MarkerVisualDataList;
    private _calloutShapes;
    calloutShapes: CalloutVisualDataList;
    private _pixels;
    pixels: number[];
    private _pixelWidth;
    pixelWidth: number;
    private _pixelHeight;
    pixelHeight: number;
    m(): void;
    serialize(): string;
}
