import { Base, Type } from "igniteui-angular-core/ES5/type";
import { PieSliceVisualData } from "./PieSliceVisualData";
import { BrushAppearanceData } from "igniteui-angular-core/ES5/BrushAppearanceData";
import { DoughnutChartLabelVisualData } from "./DoughnutChartLabelVisualData";
import { PrimitiveVisualData } from "igniteui-angular-core/ES5/PrimitiveVisualData";
import { PointData } from "igniteui-angular-core/ES5/PointData";
import { RectData } from "igniteui-angular-core/ES5/RectData";
/**
 * @hidden
 */
export declare class SliceVisualData extends Base {
    static $t: Type;
    private _pieSlice;
    pieSlice: PieSliceVisualData;
    private _outline;
    outline: BrushAppearanceData;
    private _labelVisualData;
    labelVisualData: DoughnutChartLabelVisualData;
    private _backgroundPath;
    backgroundPath: PrimitiveVisualData;
    private _origin;
    origin: PointData;
    private _explodedOrigin;
    explodedOrigin: PointData;
    private _isExploded;
    isExploded: boolean;
    private _isSelected;
    isSelected: boolean;
    private _index;
    index: number;
    private _radius;
    radius: number;
    private _startAngle;
    startAngle: number;
    private _endAngle;
    endAngle: number;
    private _visibility;
    visibility: boolean;
    scaleByViewport(a: RectData): void;
    serialize(): string;
}
