/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-angular-core/ES5/number";
/**
 * @hidden
 */
var StrategyBasedIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.qq();
        return _this;
    }
    StrategyBasedIndicator.prototype.qq = function () {
        this.qb = this.qc;
        this.ab = this.qp;
    };
    StrategyBasedIndicator.prototype.qi = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.qr = function (a) {
    };
    StrategyBasedIndicator.prototype.qk = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.qh = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.qv = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.qf.add(c);
        return d;
    };
    StrategyBasedIndicator.qu = function (a, b) {
        return StrategyBasedIndicator.qv(a, b, "Period");
    };
    StrategyBasedIndicator.qs = function (a, b) {
        return StrategyBasedIndicator.qv(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.qw = function (a, b) {
        return StrategyBasedIndicator.qv(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.po = function (a, b) {
        var c = this.mk(a, b);
        var d = this.ml(c);
        return this.qb.b(c, d);
    };
    StrategyBasedIndicator.prototype.pl = function (a, b) {
        var c = this.mk(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.nh(this.po(a, b))) {
            return false;
        }
        var d = this.ml(c);
        if (this.pi != null) {
            c.minimumValue = this.pi.c;
            c.maximumValue = this.pi.b;
        }
        var e = this.qb.a(c, d);
        for (var f = 0; f < this.pq && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.mt != null && this.qe(c)) {
            this.mt.cl();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.qe = function (a) {
        var e_1, _a;
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.pi;
            this.pi = new AxisRange(a.minimumValue, a.maximumValue);
            return this.qd(b, this.pi);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _b = tslib_1.__values(fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var f = this.pi;
        this.pi = new AxisRange(c, d);
        return this.qd(f, this.pi);
    };
    StrategyBasedIndicator.prototype.qd = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.qj = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.mk = function (a, b) {
        var c = _super.prototype.mk.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.qj(this.qi());
        c.shortPeriod = this.qj(this.qk());
        c.longPeriod = this.qj(this.qh());
        c.multiplier = this.qg();
        return c;
    };
    StrategyBasedIndicator.prototype.qg = function () {
        return 1;
    };
    StrategyBasedIndicator.qt = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.qf.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (StrategyBasedIndicator.qf.contains(b)) {
            if (this.mt != null && !this.mt.cl()) {
                this.mo.bu.e(this.eu);
                this.pl(0, this.indicatorColumn.count);
                if (this.pj.b4) {
                    this.pj.b2.g$i();
                }
                this.jd(false);
            }
        }
    };
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.qf = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
//# sourceMappingURL=StrategyBasedIndicator.js.map