import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Describes available behaviors for displaying of gridlines, tickmarks, and labels on a time axis.
 */
export declare enum TimeAxisDisplayType {
    /**
     * Points occur at even intervals, even where data is not present at a given point.
     */
    Continuous = 0,
    /**
     * Points occur when data is present, possibly at uneven intervals.
     */
    Discrete = 1
}
/**
 * @hidden
 */
export declare let TimeAxisDisplayType_$type: Type;
