import * as tslib_1 from "tslib";
import { AssigningCategoryStyleEventArgsBase } from "./igx-assigning-category-style-event-args-base";
import { AssigningCategoryMarkerStyleEventArgs as AssigningCategoryMarkerStyleEventArgs_internal } from "./AssigningCategoryMarkerStyleEventArgs";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `assigningCategoryMarkerStyle` event fired to allow you to override the style of markers for the items in a category or financial series.
*/
var AssigningCategoryMarkerStyleEventArgs = /** @class */ (function (_super) {
    tslib_1.__extends(AssigningCategoryMarkerStyleEventArgs, _super);
    function AssigningCategoryMarkerStyleEventArgs() {
        return _super.call(this) || this;
    }
    AssigningCategoryMarkerStyleEventArgs.prototype.createImplementation = function () {
        return new AssigningCategoryMarkerStyleEventArgs_internal();
    };
    Object.defineProperty(AssigningCategoryMarkerStyleEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return AssigningCategoryMarkerStyleEventArgs;
}(AssigningCategoryStyleEventArgsBase));
export { AssigningCategoryMarkerStyleEventArgs };
//# sourceMappingURL=igx-assigning-category-marker-style-event-args.js.map