import { CalloutContentUpdatingEventArgs as CalloutContentUpdatingEventArgs_internal } from "./CalloutContentUpdatingEventArgs";
/**
 * Represents event arguments for updating content of callout layer
*/
var CalloutContentUpdatingEventArgs = /** @class */ (function () {
    function CalloutContentUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    CalloutContentUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutContentUpdatingEventArgs_internal();
    };
    Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    CalloutContentUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    CalloutContentUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "content", {
        /**
         * Gets or sets content displayed by callout layer
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    return CalloutContentUpdatingEventArgs;
}());
export { CalloutContentUpdatingEventArgs };
//# sourceMappingURL=igx-callout-content-updating-event-args.js.map