import { IgxSeriesComponent } from "./igx-series-component";
/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*/
var ChartSeriesEventArgs = /** @class */ (function () {
    function ChartSeriesEventArgs() {
    }
    Object.defineProperty(ChartSeriesEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    ChartSeriesEventArgs.prototype.onImplementationCreated = function () {
    };
    ChartSeriesEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(ChartSeriesEventArgs.prototype, "series", {
        /**
         * Gets the series.
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgxSeriesComponent._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return ChartSeriesEventArgs;
}());
export { ChartSeriesEventArgs };
//# sourceMappingURL=igx-chart-series-event-args.js.map