import { IgxSeriesComponent } from './igx-series-component';
import { FinancialChartCustomIndicatorArgs as FinancialChartCustomIndicatorArgs_internal } from "./FinancialChartCustomIndicatorArgs";
/**
 * Event arguments for the Financial Chart's custom indicator event.
*/
export declare class FinancialChartCustomIndicatorArgs {
    protected _implementation: any;
    readonly i: FinancialChartCustomIndicatorArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    readonly indicatorInfo: any;
    /**
 * The Series in context.
*/
    series: IgxSeriesComponent;
    /**
     * An integer representing the position of the associated custom indicator in its host.
    */
    index: number;
}
