import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Contains PieChart label click event data.
*/
var LabelClickEventArgs = /** @class */ (function () {
    function LabelClickEventArgs() {
    }
    Object.defineProperty(LabelClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    LabelClickEventArgs.prototype.onImplementationCreated = function () {
    };
    LabelClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(LabelClickEventArgs.prototype, "item", {
        /**
         * Gets the slice data context.
        */
        get: function () {
            return this.i.item;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LabelClickEventArgs.prototype, "allowSliceClick", {
        /**
         * Gets and sets whether or not the owning pie chart should fire its SliceClick event
        */
        get: function () {
            return this.i.allowSliceClick;
        },
        set: function (v) {
            this.i.allowSliceClick = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return LabelClickEventArgs;
}());
export { LabelClickEventArgs };
//# sourceMappingURL=igx-label-click-event-args.js.map