import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core/ES5/IgCollection";
import { markType } from "igniteui-angular-core/ES5/type";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES5/SyncableObservableCollection$2";
import { RingSeriesBase as RingSeriesBase_internal } from './RingSeriesBase';
import { IgxRingSeriesBaseComponent as IgxRingSeriesBaseComponent } from './igx-ring-series-base-component';
var RingSeriesCollection = /** @class */ (function (_super) {
    tslib_1.__extends(RingSeriesCollection, _super);
    function RingSeriesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxRingSeriesBaseComponent.$type) {
            IgxRingSeriesBaseComponent.$type = markType(IgxRingSeriesBaseComponent, "IgxRingSeriesBaseComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    RingSeriesCollection.prototype._createInnerColl = function () {
        if (!IgxRingSeriesBaseComponent.$type) {
            IgxRingSeriesBaseComponent.$type = markType(IgxRingSeriesBaseComponent, "IgxRingSeriesBaseComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxRingSeriesBaseComponent.$type, RingSeriesBase_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgxRingSeriesBaseComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return RingSeriesCollection;
}(IgCollection));
export { RingSeriesCollection };
//# sourceMappingURL=igx-ring-series-collection.js.map