import { ScalerParams as ScalerParams_internal } from "./ScalerParams";
/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
*/
export declare class ScalerParams {
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ScalerParams_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The series reference value.
     * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
    */
    referenceValue: number;
}
