import { Type } from '@angular/core';
import { UnknownValuePlotting } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterLineSeries } from "./ScatterLineSeries";
/**
 * Represents a IgxDataChartComponent scatter line series
*/
export declare const IgxScatterLineSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxScatterLineSeriesComponent extends IgxScatterBaseComponent {
    protected createImplementation(): ScatterLineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: ScatterLineSeries;
    constructor();
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting: UnknownValuePlotting;
}
