import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core/ES5/IgCollection";
import { markType } from "igniteui-angular-core/ES5/type";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES5/SyncableObservableCollection$2";
import { StackedFragmentSeries as StackedFragmentSeries_internal } from './StackedFragmentSeries';
import { IgxStackedFragmentSeriesComponent as IgxStackedFragmentSeriesComponent } from './igx-stacked-fragment-series-component';
var StackedSeriesCollection = /** @class */ (function (_super) {
    tslib_1.__extends(StackedSeriesCollection, _super);
    function StackedSeriesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxStackedFragmentSeriesComponent.$type) {
            IgxStackedFragmentSeriesComponent.$type = markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    StackedSeriesCollection.prototype._createInnerColl = function () {
        if (!IgxStackedFragmentSeriesComponent.$type) {
            IgxStackedFragmentSeriesComponent.$type = markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxStackedFragmentSeriesComponent.$type, StackedFragmentSeries_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxStackedFragmentSeriesComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return StackedSeriesCollection;
}(IgCollection));
export { StackedSeriesCollection };
//# sourceMappingURL=igx-stacked-series-collection.js.map