import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core/ES5/IgCollection";
import { markType } from "igniteui-angular-core/ES5/type";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES5/SyncableObservableCollection$2";
import { TimeAxisInterval as TimeAxisInterval_internal } from './TimeAxisInterval';
import { IgxTimeAxisIntervalComponent as IgxTimeAxisIntervalComponent } from './igx-time-axis-interval-component';
var TimeAxisIntervalCollection = /** @class */ (function (_super) {
    tslib_1.__extends(TimeAxisIntervalCollection, _super);
    function TimeAxisIntervalCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxTimeAxisIntervalComponent.$type) {
            IgxTimeAxisIntervalComponent.$type = markType(IgxTimeAxisIntervalComponent, "IgxTimeAxisIntervalComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    TimeAxisIntervalCollection.prototype._createInnerColl = function () {
        if (!IgxTimeAxisIntervalComponent.$type) {
            IgxTimeAxisIntervalComponent.$type = markType(IgxTimeAxisIntervalComponent, "IgxTimeAxisIntervalComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxTimeAxisIntervalComponent.$type, TimeAxisInterval_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxTimeAxisIntervalComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return TimeAxisIntervalCollection;
}(IgCollection));
export { TimeAxisIntervalCollection };
//# sourceMappingURL=igx-time-axis-interval-collection.js.map