import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TypeRegistrar } from "igniteui-angular-core/ES5/type";
import { IgxTimeAxisIntervalComponent } from './igx-time-axis-interval-component';
import { TimeAxisInterval } from './TimeAxisInterval';
import { TimeAxisIntervalCollection as TimeAxisIntervalCollection_internal } from './TimeAxisIntervalCollection';
import { TimeAxisIntervalCollection } from './igx-time-axis-interval-collection';
var IgxTimeAxisIntervalModule = /** @class */ (function () {
    function IgxTimeAxisIntervalModule() {
        TypeRegistrar.registerCons("IgxTimeAxisIntervalComponent", IgxTimeAxisIntervalComponent);
        TypeRegistrar.registerCons("IgxTimeAxisIntervalCollection", TimeAxisIntervalCollection);
        TypeRegistrar.register("TimeAxisInterval", TimeAxisInterval.$type);
        TypeRegistrar.register("TimeAxisIntervalCollection", TimeAxisIntervalCollection_internal.$type);
    }
    IgxTimeAxisIntervalModule = tslib_1.__decorate([
        NgModule({
            imports: [
                CommonModule,
            ],
            declarations: [
                IgxTimeAxisIntervalComponent
            ],
            exports: [
                IgxTimeAxisIntervalComponent
            ],
            entryComponents: [
                IgxTimeAxisIntervalComponent
            ]
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTimeAxisIntervalModule);
    return IgxTimeAxisIntervalModule;
}());
export { IgxTimeAxisIntervalModule };
//# sourceMappingURL=igx-time-axis-interval-module.js.map