import { Base, EventArgs, Type } from "igniteui-angular-core/ES2015/type";
import { IAxisAnnotationManager } from "./IAxisAnnotationManager";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { FrameworkElement } from "igniteui-angular-core/ES2015/FrameworkElement";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core/ES2015/NotifyCollectionChangedEventArgs";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
/**
 * @hidden
 */
export declare class AxisAnnotationManager extends Base implements IAxisAnnotationManager {
    static $t: Type;
    private _owner;
    owner: Axis;
    onAddAnnotations(a: Axis): void;
    private a;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
    private b;
    private c;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
}
