/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core/ES2015/type";
/**
 * Enumeration that determines whether the axis extent measures in pixels or percentage.
 */
export var AxisExtentType;
(function (AxisExtentType) {
    /**
     * Axis extent measured in pixels
     */
    AxisExtentType[AxisExtentType["Pixel"] = 0] = "Pixel";
    /**
     * Axis extent measured as a percentage of the chart's size
     */
    AxisExtentType[AxisExtentType["Percent"] = 1] = "Percent";
})(AxisExtentType || (AxisExtentType = {}));
/**
 * @hidden
 */
export let AxisExtentType_$type = markEnum('AxisExtentType', 'Pixel,0|Percent,1');
//# sourceMappingURL=AxisExtentType.js.map