import { TrendLineManagerBase$1 } from "./TrendLineManagerBase$1";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { TrendLineManagerType } from "./TrendLineManagerType";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { PreparationParams } from "./PreparationParams";
import { ValuesHolder } from "./ValuesHolder";
import { IList$1, Point, Type } from "igniteui-angular-core/ES2015/type";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
/**
 * @hidden
 */
export declare abstract class CategoryTrendLineManagerBase extends TrendLineManagerBase$1<number> implements IPreparesCategoryTrendline {
    static $t: Type;
    constructor();
    protected get_g$a(): TrendLineManagerType;
    readonly g$a: TrendLineManagerType;
    prepareLine(a: IHasCategoryTrendline, b: PreparationParams, c: ValuesHolder, d: number): void;
    abstract prepareLineCore(a: List$1<Point>, b: TrendLineType, c: IList$1<number>, d: number, e: (arg1: number) => number, f: (arg1: number) => number, g: TrendResolutionParams): void;
}
