import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "igniteui-angular-core/ES2015/type";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewer } from "./SeriesViewer";
import { CategoryMode } from "./CategoryMode";
import { IGetItemAtIndex } from "igniteui-angular-core/ES2015/IGetItemAtIndex";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryXAxis extends CategoryAxisBase {
    static $t: Type;
    a1(): AxisView;
    gs(a: AxisView): void;
    kx: CategoryXAxisView;
    constructor();
    private k9;
    lb: number;
    private k8;
    la: number;
    as(): AxisLabelPanelBase;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jr(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    dj(): number;
    lg(a: any): void;
    dw(a: number, b: ScalerParams): number;
    protected kw(a: IList$1<number[]>): number[][];
    gm(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    dx(a: number, b: ScalerParams, c: CategoryMode): number;
    private k5;
    dz(a: number, b: ScalerParams): number;
    d0(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    lh(a: number, b: number): void;
    protected g7(a: boolean): void;
    cn(): boolean;
    static readonly li: DependencyProperty;
    k6: number;
    private kz;
    k1: number;
    d7(): number;
    static readonly lj: DependencyProperty;
    k7: number;
    private k0;
    k2: number;
    ji(a: SeriesViewer): boolean;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    protected ky(): IGetItemAtIndex;
    protected k4(a: number, b: ScalerParams): number;
    protected k3(a: number, b: number, c: boolean, d: ScalerParams): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class CategoryXAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryXAxis;
    constructor(a: CategoryXAxis);
}
