/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core/ES2015/type";
/**
 * Describes available modes of interpolation on a color scale.
 */
export var ColorScaleInterpolationMode;
(function (ColorScaleInterpolationMode) {
    /**
     * Select one of the colors in the palette.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["Select"] = 0] = "Select";
    /**
     * Interpolate between colors in the palette using RGB interpolation.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateRGB"] = 1] = "InterpolateRGB";
    /**
     * Interpolate between colors in the palette using HSV interpolation.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateHSV"] = 2] = "InterpolateHSV";
})(ColorScaleInterpolationMode || (ColorScaleInterpolationMode = {}));
/**
 * @hidden
 */
export let ColorScaleInterpolationMode_$type = markEnum('ColorScaleInterpolationMode', 'Select,0|InterpolateRGB,1|InterpolateHSV,2');
//# sourceMappingURL=ColorScaleInterpolationMode.js.map