import { Base, IList$1, Type } from "igniteui-angular-core/ES2015/type";
import { ITrackShadeVisual } from "./ITrackShadeVisual";
import { TrackShadeOrientation } from "./TrackShadeOrientation";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
/**
 * @hidden
 */
export declare class DefaultTrackShadeVisual extends Base implements ITrackShadeVisual {
    static $t: Type;
    private _translateX;
    translateX: number;
    private _translateY;
    translateY: number;
    constructor();
    getShadeBoxDefaultBrush(): Brush;
    getShadeOutlineDefaultBrush(): Brush;
    getShadeOutlineDefaultStrokeThickness(): number;
    private d;
    private e;
    private a;
    orientation: TrackShadeOrientation;
    private c;
    width: number;
    private f;
    private b;
    height: number;
    private _shadeBox;
    shadeBox: Path;
    private _shadeOutline;
    shadeOutline: Path;
    private _allPaths;
    allPaths: IList$1<Path>;
}
