import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
export declare enum FinancialOverlayType {
    /**
     * Bollinger bands overlay.
     */
    BollingerBands = 0,
    /**
     * Price channel overlay.
     */
    PriceChannel = 1
}
/**
 * @hidden
 */
export declare let FinancialOverlayType_$type: Type;
