/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core/ES2015/type";
/**
 * Describes available modes of displaying elements in the chart grid, such as gridlines.
 */
export var GridMode;
(function (GridMode) {
    /**
     * No chart grid.
     */
    GridMode[GridMode["None"] = 0] = "None";
    /**
     * Chart grid should be rendered before or in front of the data series.
     */
    GridMode[GridMode["BeforeSeries"] = 1] = "BeforeSeries";
    /**
     * Chart grid should be rendered behind or in back of the data series.
     */
    GridMode[GridMode["BehindSeries"] = 2] = "BehindSeries";
})(GridMode || (GridMode = {}));
/**
 * @hidden
 */
export let GridMode_$type = markEnum('GridMode', 'None,0|BeforeSeries,1|BehindSeries,2');
//# sourceMappingURL=GridMode.js.map