import { IScaler } from "./IScaler";
import { CategoryMode } from "./CategoryMode";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export interface ICategoryScaler extends IScaler {
    readonly categoryMode: CategoryMode;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    readonly isVertical: boolean;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
}
/**
 * @hidden
 */
export declare let ICategoryScaler_$type: Type;
