import { IHasTrendline } from "./IHasTrendline";
import { Type, Point, IList$1 } from "igniteui-angular-core/ES2015/type";
import { PreparationParams } from "./PreparationParams";
import { ValuesHolder } from "./ValuesHolder";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { TrendResolutionParams } from "./TrendResolutionParams";
/**
 * @hidden
 */
export interface IHasCategoryTrendline extends IHasTrendline {
    readonly trendlinePreparer: IPreparesCategoryTrendline;
    readonly trendLinePeriod: number;
    readonly isVertical: boolean;
}
/**
 * @hidden
 */
export declare let IHasCategoryTrendline_$type: Type;
/**
 * @hidden
 */
export interface IPreparesCategoryTrendline {
    prepareLine(a: IHasCategoryTrendline, b: PreparationParams, c: ValuesHolder, d: number): void;
    prepareLineCore(a: List$1<Point>, b: TrendLineType, c: IList$1<number>, d: number, e: (arg1: number) => number, f: (arg1: number) => number, g: TrendResolutionParams): void;
}
/**
 * @hidden
 */
export declare let IPreparesCategoryTrendline_$type: Type;
