import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES2015/type";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
/**
 * @hidden
 */
export declare class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    protected get_qc(): IndicatorCalculationStrategy;
    protected readonly qc: IndicatorCalculationStrategy;
    protected get_qp(): Type;
    protected readonly qp: Type;
    shortPeriod: number;
    static readonly qy: DependencyProperty;
    protected qk(): number;
    longPeriod: number;
    static readonly qx: DependencyProperty;
    protected qh(): number;
}
