import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * Describes available types of Spline calculations.
 */
export declare enum SplineType {
    /**
     * Calculates the spline using a natural spline calculation formula.
     */
    Natural = 0,
    /**
     * Calculated the spline using a clamped spline calculation formula.
     */
    Clamped = 1
}
/**
 * @hidden
 */
export declare let SplineType_$type: Type;
