import { Base, Type } from "igniteui-angular-core/ES2015/type";
import { SeriesViewer } from "./SeriesViewer";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { ITileZoomTile } from "./ITileZoomTile";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { TileZoomTileInfo } from "./TileZoomTileInfo";
import { ITileZoomTileInfo } from "./ITileZoomTileInfo";
import { LinkedListNode$1 } from "igniteui-angular-core/ES2015/LinkedListNode$1";
/**
 * @hidden
 */
export declare class TileZoomManager extends Base {
    static $t: Type;
    protected e: SeriesViewer;
    protected av: Rect;
    aw: Rect;
    au: Rect;
    protected i: boolean;
    protected v: number;
    protected k: Dictionary$2<TileZoomTile, ITileZoomTile>;
    protected l: Dictionary$2<TileZoomTile, ITileZoomTile>;
    protected n: List$1<ITileZoomTile>;
    constructor(a: SeriesViewer, b: boolean, c: number);
    private q;
    private ai;
    protected ao: Rect;
    private ap;
    private t;
    private s;
    private an;
    private am;
    private aj;
    private p;
    private r;
    private j;
    private g;
    private ag;
    private aa;
    private ak;
    private ad;
    private z;
    private b;
    private ar;
    private as;
    private y;
    private c;
    protected o: List$1<TileZoomTileInfo>;
    protected m: List$1<TileZoomTile>;
    private a;
    private aq;
    private at;
    private af;
    private x;
    protected d: TileZoomTileCache;
    private f;
    ab(): void;
    al(): void;
    ah(): void;
    h: boolean;
    ae(a: TileZoomTile): void;
    ac(): void;
}
/**
 * @hidden
 */
export declare class TileZoomTileCache extends Base {
    static $t: Type;
    private c;
    private d;
    private e;
    private a;
    constructor(a: number, b: TileZoomManager);
    g(): void;
    i(a: TileZoomTile): void;
    f(a: TileZoomTile): void;
    private h;
    b(a: TileZoomTileInfo): TileZoomTile;
}
/**
 * @hidden
 */
export declare class TileZoomTile extends Base implements ITileZoomTile {
    static $t: Type;
    private _info;
    info: ITileZoomTileInfo;
    a: TileZoomTileCache;
    b: LinkedListNode$1<TileZoomTile>;
    touch(): void;
    private _content;
    content: any;
    private _xPosition;
    xPosition: number;
    private _width;
    width: number;
    private _yPosition;
    yPosition: number;
    private _height;
    height: number;
    private _iD;
    iD: number;
}
