/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { InteractivityFactoryManager } from './InteractivityFactoryManager';
import { IgxDataChartDefaultTooltipsComponent } from './igx-data-chart-default-tooltips-component';
import { IgxDVInteractivityDynamicModule } from "igniteui-angular-core/ES2015/igx-dv-interactivity-dynamic-module";
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
let IgxDataChartInteractivityDynamicModule = class IgxDataChartInteractivityDynamicModule {
    constructor() {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        TypeRegistrar.registerCons('IgxDataChartDefaultTooltipsComponent', IgxDataChartDefaultTooltipsComponent);
    }
};
IgxDataChartInteractivityDynamicModule = tslib_1.__decorate([
    NgModule({
        declarations: [IgxDataChartDefaultTooltipsComponent],
        exports: [IgxDataChartDefaultTooltipsComponent,
            IgxDVInteractivityDynamicModule
        ],
        imports: [CommonModule, IgxDVInteractivityDynamicModule
        ],
        entryComponents: [IgxDataChartDefaultTooltipsComponent]
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxDataChartInteractivityDynamicModule);
export { IgxDataChartInteractivityDynamicModule };
//# sourceMappingURL=igx-data-chart-interactivity-dynamic-module.js.map