import * as tslib_1 from "tslib";
var IgxHierarchicalRingSeriesComponent_1;
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxRingSeriesBaseComponent } from "./igx-ring-series-base-component";
import { HierarchicalRingSeries } from "./HierarchicalRingSeries";
/**
 * Represents a IgxDoughnutChartComponent hierarchical series.
*/
export const IgxHierarchicalRingSeriesComponent_PROVIDERS = [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxHierarchicalRingSeriesComponent) }];
let IgxHierarchicalRingSeriesComponent = IgxHierarchicalRingSeriesComponent_1 = class IgxHierarchicalRingSeriesComponent extends IgxRingSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new HierarchicalRingSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the property name that contains the children items collection.
    */
    get childrenMemberPath() {
        return this.i.d2;
    }
    set childrenMemberPath(v) {
        this.i.d2 = v;
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxHierarchicalRingSeriesComponent.prototype, "childrenMemberPath", null);
IgxHierarchicalRingSeriesComponent = IgxHierarchicalRingSeriesComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-hierarchical-ring-series',
        template: ``,
        providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxHierarchicalRingSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxHierarchicalRingSeriesComponent);
export { IgxHierarchicalRingSeriesComponent };
//# sourceMappingURL=igx-hierarchical-ring-series-component.js.map