import { Type } from '@angular/core';
import { UnknownValuePlotting } from "igniteui-angular-core/ES2015/UnknownValuePlotting";
import { IgxPolarLineSeriesBaseComponent } from "./igx-polar-line-series-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarLineSeries } from "./PolarLineSeries";
/**
 * Represents a IgxDataChartComponent polar line series.
*/
export declare const IgxPolarLineSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxPolarLineSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    protected createImplementation(): PolarLineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: PolarLineSeries;
    constructor();
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting: UnknownValuePlotting;
}
