import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Enumeration that determines whether the axis extent measures in pixels or percentage.
 */
export declare enum AxisExtentType {
    /**
     * Axis extent measured in pixels
     */
    Pixel = 0,
    /**
     * Axis extent measured as a percentage of the chart's size
     */
    Percent = 1
}
/**
 * @hidden
 */
export declare let AxisExtentType_$type: Type;
