import { Base, Type } from "igniteui-angular-core/ES5/type";
import { RectData } from "igniteui-angular-core/ES5/RectData";
import { PrimitiveVisualData } from "igniteui-angular-core/ES5/PrimitiveVisualData";
import { AxisLabelVisualDataList } from "./AxisLabelVisualDataList";
import { ChartTitleVisualData } from "./ChartTitleVisualData";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { RectangleVisualData } from "igniteui-angular-core/ES5/RectangleVisualData";
/**
 * @hidden
 */
export declare class AxisVisualData extends Base {
    static $t: Type;
    constructor();
    private _name;
    name: string;
    private _type;
    type: string;
    private _viewport;
    viewport: RectData;
    private _tickMarksLength;
    tickMarksLength: number;
    private _tickMarks;
    tickMarks: PrimitiveVisualData;
    private _labels;
    labels: AxisLabelVisualDataList;
    private _axisLine;
    axisLine: PrimitiveVisualData;
    private _majorLines;
    majorLines: PrimitiveVisualData;
    private _minorLines;
    minorLines: PrimitiveVisualData;
    private _strips;
    strips: PrimitiveVisualData;
    private _labelsPlotArea;
    labelsPlotArea: RectData;
    private _labelsViewport;
    labelsViewport: RectData;
    private _title;
    title: ChartTitleVisualData;
    private _annotationBackings;
    annotationBackings: List$1<RectangleVisualData>;
    p(): void;
    serialize(): string;
}
