import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Describes available types for enabling error bars
 */
export declare enum EnableErrorBars {
    /**
     * No error bars are enabled
     */
    None = 0,
    /**
     * Both error bars are enabled
     */
    Both = 1,
    /**
     * Positive error bars are enabled
     */
    Positive = 2,
    /**
     * Negative error bars are enabled
     */
    Negative = 3
}
/**
 * @hidden
 */
export declare let EnableErrorBars_$type: Type;
