import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Describes available highlighting states
 */
export declare enum HighlightingState {
    /**
     * Highlight is transitioning out.
     */
    outward = 0,
    /**
     * Highlight is transitioning in.
     */
    inward = 1,
    /**
     * Highlight is active and not transitioning in or out.
     */
    Static = 2
}
/**
 * @hidden
 */
export declare let HighlightingState_$type: Type;
