import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point, Type } from "igniteui-angular-core/ES5/type";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export declare abstract class HorizontalRangeCategorySeries extends RangeCategorySeries {
    static $t: Type;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ht(): void;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected get_c3(): boolean;
    protected bd(): SeriesHitTestMode;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    fc(a: Point, b: boolean): number;
    fe(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    en(a: Point, b: boolean, c: boolean): number;
    el(a: Point, b: boolean, c: boolean): number;
    ej(a: Point, b: boolean, c: boolean): number;
    lh(a: Point, b: boolean, c: boolean): Point;
    lj(a: Point, b: boolean, c: boolean): Point;
    ll(a: Point, b: boolean, c: boolean): Point;
    n1(): boolean;
    protected iz(a: any, b: string, c: any, d: any): void;
    pe(a: any): boolean;
    pd(a: any): boolean;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
