import { PropertyChangedEventArgs, Type } from "igniteui-angular-core/ES5/type";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
/**
 * @hidden
 */
export interface IAxisAnnotation {
    readonly text: string;
    readonly value: any;
    resolveLabelValue(): string;
    formatLabel: (item: any) => string;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    readonly textColor: Brush;
    readonly background: Brush;
    readonly outline: Brush;
    readonly strokeThickness: number;
    readonly backgroundPadding: Thickness;
    checkForExtentReset(a: () => void): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotation_$type: Type;
