import { Rect } from "igniteui-angular-core/ES5/Rect";
import { EventArgs, Type } from "igniteui-angular-core/ES5/type";
/**
 * @hidden
 */
export interface ITimeRangeSelectorAxis {
    readonly actualMinimumValue: Date;
    readonly actualMaximumValue: Date;
    readonly visibleMinimum: Date;
    readonly visibleMaximum: Date;
    getWindowRectForSelection(a: Date, b: Date): Rect;
    visibleRangeChanged: (sender: any, e: EventArgs) => void;
    readonly dateTimeMemberPath: string;
    itemLabelFormat(): string;
    minimumValue: Date;
    maximumValue: Date;
}
/**
 * @hidden
 */
export declare let ITimeRangeSelectorAxis_$type: Type;
