/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { Base, Type, runOn, Number_$type, enumGetBox, typeCast, Point_$type, fromEnum, markType } from "igniteui-angular-core/ES5/type";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { PenLineCap_$type } from "igniteui-angular-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES5/DoubleCollection";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES5/IFastItemsSource";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-angular-core/ES5/HashPool$2";
import { Clipper } from "igniteui-angular-core/ES5/Clipper";
import { Dictionary$2 } from "igniteui-angular-core/ES5/Dictionary$2";
import { OwnedPoint } from "./OwnedPoint";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { isNaN_, isInfinity } from "igniteui-angular-core/ES5/number";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { GeometryGroup } from "igniteui-angular-core/ES5/GeometryGroup";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES5/string";
/**
 * @hidden
 */
var PolarBase = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBase, _super);
    function PolarBase() {
        var _this = _super.call(this) || this;
        _this.m8 = null;
        _this.m1 = null;
        _this.m6 = null;
        _this.oy = null;
        _this.ox = null;
        _this.ne = null;
        _this.ng = null;
        _this.nh = null;
        _this.nb = new PolarFrame();
        _this.nd = new PolarFrame();
        _this.na = new PolarFrame();
        _this.m5 = null;
        _this.nc = null;
        _this.m9 = null;
        _this.nc = new PolarFrame();
        _this.nd.x = runOn(_this, _this.ow);
        _this.nb.x = runOn(_this, _this.ow);
        _this.na.x = runOn(_this, _this.ow);
        _this.ne = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(_this, _this.n9), runOn(_this, _this.ob), runOn(_this, _this.ca), runOn(_this, _this.jl), runOn(_this, _this.n7));
        return _this;
    }
    PolarBase.prototype.bf = function () {
        return new PolarBaseView(this);
    };
    PolarBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m7 = a;
    };
    PolarBase.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.m3 = null;
        this.m4 = null;
    };
    PolarBase.prototype.get_c0 = function () {
        return true;
    };
    PolarBase.prototype.nn = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.m3;
        var c = new ScalerParams(1, this.bs.mq, this.ly, b.b8);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.m4;
        var e = new ScalerParams(1, this.bs.mq, this.ly, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.l0.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.ly.left || h > _this.ly.right || i < _this.ly.top || i > _this.ly.bottom) {
                    return;
                }
                g.b = b.dz(h, c);
                g.c = d.dz(i, e);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    PolarBase.prototype.n7 = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    PolarBase.prototype.n8 = function () {
        this.m5.e(this.m8.w, this.ni, this.nj, this.oy, this.ox, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
    };
    Object.defineProperty(PolarBase.prototype, "ni", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            if (this.ng != a) {
                var b = this.ni;
                this.ng = a;
                this.raisePropertyChanged("AngleColumn", b, this.ni);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "nj", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            if (this.nh != a) {
                var b = this.nj;
                this.nh = a;
                this.raisePropertyChanged("RadiusColumn", b, this.nj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "or", {
        get: function () {
            return this.c(PolarBase.oc);
        },
        set: function (a) {
            this.h(PolarBase.oc, a);
        },
        enumerable: true,
        configurable: true
    });
    PolarBase.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.m4 != null) {
            this.m4.g6(false);
        }
        if (this.m3 != null) {
            this.m3.g6(false);
        }
    };
    PolarBase.prototype.hy = function (a, b, c, d) {
        var e = false;
        this.m7.cr.g$e(a, b, c, d);
        if (this.m3 != null && !this.m3.cl()) {
            e = true;
        }
        if (this.m4 != null && !this.m4.cl()) {
            e = true;
        }
        if (e) {
            this.jd(true);
        }
    };
    PolarBase.prototype.js = function (a, b) {
        this.jd(false);
    };
    PolarBase.prototype.jt = function (a, b) {
        this.jd(false);
    };
    PolarBase.prototype.dw = function (a, b, c) {
        var d = true;
        if (!_super.prototype.dw.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.m3 == null || this.m4 == null || this.ni == null || this.nj == null || this.ni.count == 0 || this.nj.count == 0 || this.bz == null || this.bz.count != this.ni.count || this.bz.count != this.nj.count || this.m5 == null || this.m3.bf == null || this.m4.bf == null || this.m3.j4 == this.m3.j3 || this.m4.j4 == this.m4.j3) {
            d = false;
        }
        return d;
    };
    PolarBase.prototype.je = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.hv(true, this.bi);
            return;
        }
        this.oy = b;
        this.ox = c;
        this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
        var e = new SeriesRenderingArguments(this, c, b, a, this.de);
        var f = this.ne.g(e, this.nb, this.na, this.nd, this.m7);
        this.nb = f.p1;
        this.na = f.p2;
        this.nd = f.p3;
    };
    PolarBase.prototype.ow = function (a) {
        var b = this.m5.h(a.x, a.y, this.oy, this.ox, this.m6.e, this.m6.d, this.m6.g, this.m6.f, this.m6.i, this.m6.h);
        return b;
    };
    PolarBase.prototype.an = function (a) {
        if (a != null && a == this.m3 && this.ni != null) {
            return new AxisRange(this.ni.minimum, this.ni.maximum);
        }
        if (a != null && a == this.m4 && this.nj != null) {
            return new AxisRange(this.nj.minimum, this.nj.maximum);
        }
        return null;
    };
    PolarBase.prototype.c9 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.m3 == null || this.ni == null || this.m4 == null || this.nj == null) {
            return false;
        }
        if (d < 0 || d > this.ni.count - 1 || d > this.nj.count - 1) {
            return false;
        }
        var e = this.m3.getScaledAngle(this.ni.item(d));
        var f = this.m4.lp(this.nj.item(d));
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    PolarBase.prototype.fp = function (a) {
        return null;
    };
    PolarBase.prototype.e8 = function (a) {
        return -1;
    };
    PolarBase.prototype.ag = function () {
        return [this.m3, this.m4];
    };
    PolarBase.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == PolarBase.$$p[1]) {
            return this.ft(a, b, this.nw);
        }
        if (c == PolarBase.$$p[5]) {
            return this.ft(a, b, this.n2);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    PolarBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.m7.cr.g$b(a, b, c, d)) {
            this.jd(false);
            this.ik();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.ni);
                    c.deregisterColumn(this.nj);
                    this.ni = null;
                    this.nj = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.ni = this.bw(this.nw);
                    this.nj = this.bw(this.n2);
                }
                if ((this.m4 != null && !this.m4.cl()) || (this.m3 != null && !this.m3.cl())) {
                    this.jd(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.m3 != null && this.m4 != null) {
                    this.m5 = new PolarAxes(this.m4, this.m3);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if (this.m3 != null && !this.m3.cl()) {
                    this.jd(false);
                }
                else if (c != null && d == null) {
                    this.hv(true, this.bi);
                }
                break;
            case PolarBase.$$p[4]:
                if (this.m3 != null && this.m4 != null) {
                    this.m5 = new PolarAxes(this.m4, this.m3);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if (this.m4 != null && !this.m4.cl()) {
                    this.jd(false);
                }
                else if (c != null && d == null) {
                    this.hv(true, this.bi);
                }
                if (this.m3 != null && !this.m3.cl()) {
                    this.m3.g2();
                }
                break;
            case PolarBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ni);
                    this.ni = this.bw(this.nw);
                }
                break;
            case "AngleColumn":
                this.m7.cr.g$i();
                if (this.m3 != null && !this.m3.cl()) {
                    this.jd(false);
                }
                break;
            case PolarBase.$$p[5]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nj);
                    this.nj = this.bw(this.n2);
                }
                break;
            case "RadiusColumn":
                this.m7.cr.g$i();
                if (this.m4 != null && !this.m4.cl()) {
                    this.jd(false);
                }
                break;
            case PolarBase.$$p[6]:
                this.jd(false);
                this.ik();
                break;
            case PolarBase.$$p[3]:
                this.jd(false);
                this.ik();
                break;
            case "TransitionProgress":
                this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
                this.oy = this.bi.bs;
                this.ox = this.bi.br;
                this.nd.v = this.no;
                this.nd.c(this.ez, this.nb, this.na);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.ob(this.na, this.m7);
                }
                else {
                    this.ob(this.nd, this.m7);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case PolarBase.$$p[2]:
                this.jd(false);
                this.ik();
                break;
            case "TrendLineType":
                this.ik();
                break;
        }
    };
    PolarBase.prototype.nl = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.nk = function (a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a) {
            c.cs.clear();
        }
        c.cr.g$d();
    };
    PolarBase.prototype.m2 = function (a, b) {
        var c = a.top - 10;
        var d = a.bottom + 10;
        var e = a.left - 10;
        var f = a.right + 10;
        var g = ((function () {
            var $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    };
    PolarBase.prototype.n6 = function (a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        var e = this.bz;
        var _loop_1 = function (f) {
            var g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                var h_1 = { $type: Point_$type, x: this_1.ni.item(f), y: this_1.nj.item(f) };
                var i_1 = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((function () {
                    var $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h_1;
                    $ret.c = i_1;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var f = 0; f < b; f++) {
            _loop_1(f);
        }
    };
    PolarBase.prototype.n9 = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        a.j.clear();
        a.n.clear();
        var e = Math.min(this.ni != null ? this.ni.count : 0, this.nj != null ? this.nj.count : 0);
        if (e < 1) {
            return;
        }
        this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
        this.m8 = a;
        this.ox = d;
        this.oy = c;
        b.cp.l(a.j, this.nr, c, d, this.eu);
        if (e <= this.nr) {
            this.n6(a, e, c, d);
        }
        var f = this.m2(d, a.n);
        var g = Math.min(this.m3.j4, this.m3.j3);
        var h = Math.max(this.m3.j3, this.m3.j4);
        b.cr.q = this.no;
        b.cr.p = 0;
        b.cr.s = this.m4.lj;
        b.cr.r = this.m4.li;
        b.cr.t = function (i, j) { return _this.m5.c(i, j, c, d, Math.cos); };
        b.cr.u = function (i, j) { return _this.m5.d(i, j, c, d, Math.sin); };
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < this.ni.count; j++) {
            if (this.ni.item(j) >= g && this.ni.item(j) <= h) {
                i.add(this.ni.item(j));
            }
        }
        var k = this.nj;
        if (i.count != this.ni.count) {
            k = new List$1(Number_$type, 0);
            for (var l = 0; l < this.ni.count; l++) {
                if (this.ni.item(l) >= g && this.ni.item(l) <= h) {
                    k.add(this.nj.item(l));
                }
            }
        }
        b.cr.v(a.n, this.nf, i, k, this.ns, runOn(this.m3, this.m3.getScaledAngle), runOn(this.m4, this.m4.lp), ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    };
    PolarBase.prototype.ob = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.lq(b);
        this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
        b.cp.j(a.j, this.l5);
        b.cj();
        var g = this.m2(d, b.cr.g$j.ak);
        b.cr.g$h(a.n, g);
        this.n5(d, c, e, f, b);
    };
    PolarBase.prototype.n5 = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    PolarBase.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        this.m7.cw();
    };
    PolarBase.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = this.bh;
        if (!this.df) {
            this.nc = new PolarFrame();
            this.n9(this.nc, c);
        }
        this.df = false;
        this.ob(this.nc, c);
        this.dl = false;
    };
    PolarBase.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.m9 == null) {
            this.m9 = new PolarFrame();
        }
        this.n9(this.m9, g);
        this.ob(this.m9, g);
    };
    PolarBase.prototype.oa = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = tslib_1.__values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = tslib_1.__values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    PolarBase.prototype.m0 = function (a, b, c) {
        this.n8();
        return this.m8.w.toArray();
    };
    PolarBase.prototype.np = function (a) {
        var e_3, _a;
        var b = new List$1(Number_$type, 0);
        var c = this.bz;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.m7.cs.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.add(c.indexOf(d));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return b;
    };
    PolarBase.prototype.ov = function (a) {
        return { $type: Point_$type, x: this.ni.item(a), y: this.nj.item(a) };
    };
    PolarBase.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        this.a2.exportTrendlineData(this, a, this.m7.cr.g$j);
    };
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.oc = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    return PolarBase;
}(MarkerSeries));
export { PolarBase };
Type.dep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:m3:od', [NumericAngleAxis.$, null], 'AngleMemberPath:nw:oe', [2], 'ClipSeriesToBounds:nm:of', [0, false], 'MaximumMarkers:nr:og', [1, 400], 'RadiusAxis:m4:oh', [NumericRadiusAxis.$, null], 'RadiusMemberPath:n2:oi', [2], 'UseCartesianInterpolation:no:oq', [0, true], 'TrendLineType:nf:oo', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:nq:on', [1, 1.5], 'TrendLinePeriod:ns:om', [1, 7], 'TrendLineZIndex:nt:op', [1, 1], 'TrendLineBrush:os:oj', [Brush.$, null], 'TrendLineDashArray:ot:ok', [DoubleCollection.$], 'TrendLineDashCap:ou:ol', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
var PolarBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBaseView, _super);
    function PolarBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cq = null;
        _this.cp = null;
        _this.cr = null;
        _this.cs = null;
        _this.cq = a;
        _this.cs = new HashPool$2(Base.$, Marker.$);
        _this.ce(_this.cs);
        _this.cr = new PolarTrendLineManager();
        return _this;
    }
    PolarBaseView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cp = this.co();
        if (!this.n) {
            this.cq.nr = 1000;
            this.by.l1 = 2;
        }
    };
    PolarBaseView.prototype.co = function () {
        var _this = this;
        var a = new NumericMarkerManager(0, function (b) { return _this.cs.item(b); }, function (b) { return _this.cq.m6.c.item(b); }, runOn(this, this.cv), runOn(this, this.cn), runOn(this, this.ct));
        a.n = true;
        a.p = runOn(this.cq, this.cq.ov);
        return a;
    };
    PolarBaseView.prototype.cv = function (a) {
        this.cq.oa(a, this.cs);
    };
    PolarBaseView.prototype.cn = function () {
        return this.cq.m0(this.cs, this.bs, this.br);
    };
    PolarBaseView.prototype.ct = function () {
        return this.cq.np(this.cs);
    };
    PolarBaseView.prototype.cu = function (a, b, c, d) {
        if (this.cq.nm) {
            var e = new GeometryGroup();
            this.cq.m4.lx(e, a, b, c, d);
        }
        else {
        }
    };
    PolarBaseView.prototype.cw = function () {
        if (this.cq.os != null) {
            this.cq.or = this.cq.os;
        }
        else {
            this.cq.or = this.cq.k3;
        }
    };
    PolarBaseView.prototype.cc = function (a) {
        this.cs.f(a);
    };
    PolarBaseView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cq.nf != 0 && !b) {
                var c = this.cr.g$j;
                c.ac = this.cq.nq;
                c._stroke = this.cq.or;
                c.ad = this.cq.ou;
                c.ai = this.cq.ot;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    PolarBaseView.prototype.cx = function () {
        return Rect.empty;
    };
    PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cq.nw + "}" + "</span><br/><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cq.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cq.n2 + "}</span></div>";
        return a;
    };
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
}(MarkerSeriesView));
export { PolarBaseView };
//# sourceMappingURL=PolarBase_combined.js.map