/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core/ES5/type";
import { HorizontalAlignment_$type } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { VerticalAlignment_$type } from "igniteui-angular-core/ES5/VerticalAlignment";
import { Visibility_$type } from "igniteui-angular-core/ES5/Visibility";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
var XYChart = /** @class */ (function (_super) {
    tslib_1.__extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ib = null;
        _this.ic = null;
        _this.iq = 0;
        _this.is = 5;
        _this.ir = 0;
        _this.ip = 5;
        _this.i7 = 5;
        _this.i9 = 0;
        _this.i8 = 5;
        _this.i6 = 0;
        _this.nl = null;
        _this.ns = null;
        _this.i1 = 0;
        _this.ji = 0;
        _this.i0 = NaN;
        _this.jh = NaN;
        _this.i3 = NaN;
        _this.jk = NaN;
        _this.i2 = NaN;
        _this.jj = NaN;
        _this.iz = NaN;
        _this.jg = NaN;
        _this.nr = null;
        _this.ny = null;
        _this.kr = null;
        _this.ku = null;
        _this.kt = null;
        _this.kw = null;
        _this.kn = null;
        _this.ko = null;
        _this.nm = null;
        _this.nt = null;
        _this.it = 1;
        _this.ja = 1;
        _this.iu = 1;
        _this.jb = 0;
        _this.no = null;
        _this.nv = null;
        _this.np = null;
        _this.nw = null;
        _this.iv = 1;
        _this.jc = 1;
        _this.iw = 5;
        _this.jd = 0;
        _this.nq = null;
        _this.nx = null;
        _this.ix = 2;
        _this.je = 2;
        _this.ks = null;
        _this.kv = null;
        _this.nn = null;
        _this.nu = null;
        _this.io = 0;
        _this.i5 = 0;
        _this.im = NaN;
        _this.i4 = NaN;
        _this.iy = 0;
        _this.jf = -90;
        _this.ii = false;
        _this.ij = false;
        _this.ng = 1;
        _this.of = 1;
        _this.nf = 1;
        _this.nh = 2;
        _this.od = 0;
        _this.oe = 1;
        _this.oj = 0;
        _this.ok = 0;
        _this.ig = 2;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.h9();
            var c = this.ia();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.gj = function () {
        _super.prototype.gj.call(this);
        var a = this.h9();
        var b = this.ia();
        if (a != null && a.aw != null) {
            this.nz = a.aw.textColor;
        }
        if (b != null && b.aw != null) {
            this.n6 = b.aw.textColor;
        }
    };
    XYChart.prototype.g4 = function (a, b, c) {
        var _this = this;
        _super.prototype.g4.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.m9(function (d) { return d.leftMargin = _this.js; });
                break;
            case "XAxisLabelTopMargin":
                this.m9(function (d) { return d.topMargin = _this.ju; });
                break;
            case "XAxisLabelRightMargin":
                this.m9(function (d) { return d.rightMargin = _this.jt; });
                break;
            case "XAxisLabelBottomMargin":
                this.m9(function (d) { return d.bottomMargin = _this.jr; });
                break;
            case "YAxisLabelLeftMargin":
                this.nd(function (d) { return d.leftMargin = _this.j9; });
                break;
            case "YAxisLabelTopMargin":
                this.nd(function (d) { return d.topMargin = _this.kb; });
                break;
            case "YAxisLabelRightMargin":
                this.nd(function (d) { return d.rightMargin = _this.ka; });
                break;
            case "YAxisLabelBottomMargin":
                this.nd(function (d) { return d.bottomMargin = _this.j8; });
                break;
            case "XAxisLabelTextColor":
                this.m9(function (d) { return d.textColor = _this.nz; });
                break;
            case "YAxisLabelTextColor":
                this.nd(function (d) { return d.textColor = _this.n6; });
                break;
            case "XAxisTitleMargin":
                this.na(function (d) { return d.margin = _this.j3; });
                break;
            case "YAxisTitleMargin":
                this.ne(function (d) { return d.margin = _this.kk; });
                break;
            case "XAxisTitleLeftMargin":
                this.na(function (d) { return d.leftMargin = _this.j2; });
                break;
            case "YAxisTitleLeftMargin":
                this.ne(function (d) { return d.leftMargin = _this.kj; });
                break;
            case "XAxisTitleTopMargin":
                this.na(function (d) { return d.topMargin = _this.j5; });
                break;
            case "YAxisTitleTopMargin":
                this.ne(function (d) { return d.topMargin = _this.km; });
                break;
            case "XAxisTitleRightMargin":
                this.na(function (d) { return d.rightMargin = _this.j4; });
                break;
            case "YAxisTitleRightMargin":
                this.ne(function (d) { return d.rightMargin = _this.kl; });
                break;
            case "XAxisTitleBottomMargin":
                this.na(function (d) { return d.bottomMargin = _this.j1; });
                break;
            case "YAxisTitleBottomMargin":
                this.ne(function (d) { return d.bottomMargin = _this.ki; });
                break;
            case "XAxisTitleTextColor":
                this.na(function (d) { return d.textColor = _this.n5; });
                break;
            case "YAxisTitleTextColor":
                this.ne(function (d) { return d.textColor = _this.oc; });
                break;
            case "XAxisFormatLabel":
                this.m7(function (d) { return d.ar = _this.id; });
                break;
            case "YAxisFormatLabel":
                this.nb(function (d) { return d.ar = _this.ie; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "id", {
        get: function () {
            return this.ib;
        },
        set: function (a) {
            var b = this.id;
            if (a != b) {
                this.ib = a;
                this.g3("XAxisFormatLabel", b, this.id);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ie", {
        get: function () {
            return this.ic;
        },
        set: function (a) {
            var b = this.ie;
            if (a != b) {
                this.ic = a;
                this.g3("YAxisFormatLabel", b, this.ie);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "js", {
        get: function () {
            return this.iq;
        },
        set: function (a) {
            var b = this.js;
            if (a != b) {
                this.iq = a;
                this.g3("XAxisLabelLeftMargin", b, this.js);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ju", {
        get: function () {
            return this.is;
        },
        set: function (a) {
            var b = this.ju;
            if (a != b) {
                this.is = a;
                this.g3("XAxisLabelTopMargin", b, this.ju);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jt", {
        get: function () {
            return this.ir;
        },
        set: function (a) {
            var b = this.jt;
            if (a != b) {
                this.ir = a;
                this.g3("XAxisLabelRightMargin", b, this.jt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jr", {
        get: function () {
            return this.ip;
        },
        set: function (a) {
            var b = this.jr;
            if (a != b) {
                this.ip = a;
                this.g3("XAxisLabelBottomMargin", b, this.jr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j9", {
        get: function () {
            return this.i7;
        },
        set: function (a) {
            var b = this.j9;
            if (a != b) {
                this.i7 = a;
                this.g3("YAxisLabelLeftMargin", b, this.j9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kb", {
        get: function () {
            return this.i9;
        },
        set: function (a) {
            var b = this.kb;
            if (a != b) {
                this.i9 = a;
                this.g3("YAxisLabelTopMargin", b, this.kb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ka", {
        get: function () {
            return this.i8;
        },
        set: function (a) {
            var b = this.ka;
            if (a != b) {
                this.i8 = a;
                this.g3("YAxisLabelRightMargin", b, this.ka);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j8", {
        get: function () {
            return this.i6;
        },
        set: function (a) {
            var b = this.j8;
            if (a != b) {
                this.i6 = a;
                this.g3("YAxisLabelBottomMargin", b, this.j8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nz", {
        get: function () {
            return this.nl;
        },
        set: function (a) {
            var b = this.nz;
            if (a != b) {
                this.nl = a;
                this.g3("XAxisLabelTextColor", b, this.nz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n6", {
        get: function () {
            return this.ns;
        },
        set: function (a) {
            var b = this.n6;
            if (a != b) {
                this.ns = a;
                this.g3("YAxisLabelTextColor", b, this.n6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j3", {
        get: function () {
            return this.i1;
        },
        set: function (a) {
            var b = this.j3;
            if (a != b) {
                this.i1 = a;
                this.g3("XAxisTitleMargin", b, this.j3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kk", {
        get: function () {
            return this.ji;
        },
        set: function (a) {
            var b = this.kk;
            if (a != b) {
                this.ji = a;
                this.g3("YAxisTitleMargin", b, this.kk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j2", {
        get: function () {
            return this.i0;
        },
        set: function (a) {
            var b = this.j2;
            if (a != b) {
                this.i0 = a;
                this.g3("XAxisTitleLeftMargin", b, this.j2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kj", {
        get: function () {
            return this.jh;
        },
        set: function (a) {
            var b = this.kj;
            if (a != b) {
                this.jh = a;
                this.g3("YAxisTitleLeftMargin", b, this.kj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j5", {
        get: function () {
            return this.i3;
        },
        set: function (a) {
            var b = this.j5;
            if (a != b) {
                this.i3 = a;
                this.g3("XAxisTitleTopMargin", b, this.j5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "km", {
        get: function () {
            return this.jk;
        },
        set: function (a) {
            var b = this.km;
            if (a != b) {
                this.jk = a;
                this.g3("YAxisTitleTopMargin", b, this.km);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j4", {
        get: function () {
            return this.i2;
        },
        set: function (a) {
            var b = this.j4;
            if (a != b) {
                this.i2 = a;
                this.g3("XAxisTitleRightMargin", b, this.j4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kl", {
        get: function () {
            return this.jj;
        },
        set: function (a) {
            var b = this.kl;
            if (a != b) {
                this.jj = a;
                this.g3("YAxisTitleRightMargin", b, this.kl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j1", {
        get: function () {
            return this.iz;
        },
        set: function (a) {
            var b = this.j1;
            if (a != b) {
                this.iz = a;
                this.g3("XAxisTitleBottomMargin", b, this.j1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ki", {
        get: function () {
            return this.jg;
        },
        set: function (a) {
            var b = this.ki;
            if (a != b) {
                this.jg = a;
                this.g3("YAxisTitleBottomMargin", b, this.ki);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n5", {
        get: function () {
            return this.nr;
        },
        set: function (a) {
            var b = this.n5;
            if (a != b) {
                this.nr = a;
                this.g3("XAxisTitleTextColor", b, this.n5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oc", {
        get: function () {
            return this.ny;
        },
        set: function (a) {
            var b = this.oc;
            if (a != b) {
                this.ny = a;
                this.g3("YAxisTitleTextColor", b, this.oc);
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.g5 = function (a, b, c) {
        var _this = this;
        _super.prototype.g5.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.m9(function (d) { return d.textStyle = _this.k8; });
                break;
            case "YAxisLabelTextStyle":
                this.nd(function (d) { return d.textStyle = _this.ma; });
                break;
            case "XAxisTitleTextStyle":
                this.na(function (d) { return d.textStyle = _this.lw; });
                break;
            case "YAxisTitleTextStyle":
                this.ne(function (d) { return d.textStyle = _this.my; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "k8", {
        get: function () {
            return this.kr;
        },
        set: function (a) {
            var b = this.k8;
            if (a != b) {
                this.kr = a;
                this.g3("XAxisLabelTextStyle", b, this.k8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ma", {
        get: function () {
            return this.ku;
        },
        set: function (a) {
            var b = this.ma;
            if (a != b) {
                this.ku = a;
                this.g3("YAxisLabelTextStyle", b, this.ma);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "lw", {
        get: function () {
            return this.kt;
        },
        set: function (a) {
            var b = this.lw;
            if (a != b) {
                this.kt = a;
                this.g3("XAxisTitleTextStyle", b, this.lw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "my", {
        get: function () {
            return this.kw;
        },
        set: function (a) {
            var b = this.my;
            if (a != b) {
                this.kw = a;
                this.g3("YAxisTitleTextStyle", b, this.my);
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.m4 = function (a) {
        var _this = this;
        this.m1(a, function (b) { return b.leftMargin = _this.js; });
        this.m1(a, function (b) { return b.topMargin = _this.ju; });
        this.m1(a, function (b) { return b.rightMargin = _this.jt; });
        this.m1(a, function (b) { return b.bottomMargin = _this.jr; });
        this.m1(a, function (b) { return b.textColor = _this.nz; });
        this.m2(a, function (b) { return b.textColor = _this.n5; });
        this.m2(a, function (b) { return b.leftMargin = _this.j2; });
        this.m2(a, function (b) { return b.topMargin = _this.j5; });
        this.m2(a, function (b) { return b.rightMargin = _this.j4; });
        this.m2(a, function (b) { return b.bottomMargin = _this.j1; });
        this.m1(a, function (b) { return b.textStyle = _this.k8; });
        this.m2(a, function (b) { return b.textStyle = _this.lw; });
    };
    XYChart.prototype.m6 = function (a) {
        var _this = this;
        this.m1(a, function (b) { return b.leftMargin = _this.j9; });
        this.m1(a, function (b) { return b.topMargin = _this.kb; });
        this.m1(a, function (b) { return b.rightMargin = _this.ka; });
        this.m1(a, function (b) { return b.bottomMargin = _this.j8; });
        this.m1(a, function (b) { return b.textColor = _this.n6; });
        this.m2(a, function (b) { return b.textColor = _this.oc; });
        this.m2(a, function (b) { return b.leftMargin = _this.kj; });
        this.m2(a, function (b) { return b.topMargin = _this.km; });
        this.m2(a, function (b) { return b.rightMargin = _this.kl; });
        this.m2(a, function (b) { return b.bottomMargin = _this.ki; });
        this.m1(a, function (b) { return b.textStyle = _this.ma; });
        this.m2(a, function (b) { return b.textStyle = _this.my; });
    };
    XYChart.prototype.hk = function (a) {
        var b = this.u(a);
        var c = this.aq(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.el(a);
        c.fx = this.em(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.m7 = function (a) {
        this.m8(a, null);
    };
    XYChart.prototype.m8 = function (a, b) {
        a(this.h9());
    };
    XYChart.prototype.nc = function (a, b) {
        a(this.ia());
    };
    XYChart.prototype.nb = function (a) {
        this.nc(a, true);
    };
    XYChart.prototype.na = function (a) {
        this.m2(this.h9(), a);
    };
    XYChart.prototype.ne = function (a) {
        this.m2(this.ia(), a);
    };
    XYChart.prototype.nd = function (a) {
        this.m1(this.ia(), a);
    };
    XYChart.prototype.m9 = function (a) {
        this.m1(this.h9(), a);
    };
    XYChart.prototype.jl = function (a) {
        var b = this.h9();
        return b.dw(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.jn = function (a) {
        var b = this.h9();
        return b.dz(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.jm = function (a) {
        var b = this.ia();
        return b.dw(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.jo = function (a) {
        var b = this.ia();
        return b.dz(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.hi = function (a) {
        _super.prototype.hi.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.h9();
            var c = this.ia();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.kx = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = tslib_1.__values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return null;
    };
    XYChart.prototype.ge = function (a) {
        _super.prototype.ge.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.h9());
            this.dataChart.axes.add(this.ia());
        }
    };
    XYChart.prototype.m3 = function (a) {
        var _this = this;
        if (a != null && this.di != null && a.es == null) {
            a.provideRenderer(this.di);
        }
        a.ij = this.n0;
        a.d3 = this.jv;
        a.ik = this.n1;
        a.d6 = this.jw;
        a.im = this.n3;
        a.en = this.jx;
        a.il = this.n2;
        a.eo = this.jy;
        a.io = this.n4;
        a.ep = this.jz;
        a.co = true;
        var b = a == this.h9();
        if (b) {
            a.f7 = this.ln;
        }
        a.e7 = this.kp;
        this.m1(a, function (c) { return c.angle = _this.jq; });
        this.m1(a, function (c) {
            if (c.extent != _this.jp) {
                c.extent = _this.jp;
            }
        });
        this.m1(a, function (c) { return c.horizontalAlignment = _this.ni; });
        this.m1(a, function (c) { return c.verticalAlignment = _this.og; });
        this.m1(a, function (c) { return c.visibility = _this.ol; });
        this.m2(a, function (c) { return c.horizontalAlignment = _this.nj; });
        this.m2(a, function (c) { return c.angle = _this.j0; });
        this.m4(a);
    };
    XYChart.prototype.m5 = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.di != null && a.es == null) {
            a.provideRenderer(this.di);
        }
        this.m1(a, function (b) { return b.angle = _this.j7; });
        this.m1(a, function (b) {
            if (b.extent != _this.j6) {
                b.extent = _this.j6;
            }
        });
        this.m1(a, function (b) { return b.horizontalAlignment = _this.nk; });
        this.m1(a, function (b) { return b.verticalAlignment = _this.oh; });
        this.m1(a, function (b) { return b.visibility = _this.om; });
        this.m1(a, function (b) { return b.location = _this.ih; });
        this.m2(a, function (b) { return b.verticalAlignment = _this.oi; });
        this.m2(a, function (b) { return b.angle = _this.kh; });
        a.ij = this.n7;
        a.d3 = this.kc;
        a.ik = this.n8;
        a.d6 = this.kd;
        a.im = this.oa;
        a.en = this.ke;
        a.il = this.n9;
        a.eo = this.kf;
        a.io = this.ob;
        a.ep = this.kg;
        var b = a == this.ia();
        if (b) {
            a.f7 = this.mp;
        }
        this.m6(a);
    };
    XYChart.prototype.gb = function () {
        _super.prototype.gb.call(this);
        this.m3(this.h9());
        this.m5(this.ia());
    };
    XYChart.prototype.m1 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.aw == null) {
            a.aw = new AxisLabelSettings();
            a.aw.angle = a.dk();
            a.aw.bottomMargin = a.dl();
            a.aw.leftMargin = a.dm();
            a.aw.rightMargin = a.dn();
            a.aw.topMargin = a.dp();
            a.aw.horizontalAlignment = a.id();
            a.aw.location = a.ax();
            a.aw.verticalAlignment = a.i8();
        }
        b(a.aw);
    };
    XYChart.prototype.m2 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bc == null) {
            a.bc = new TitleSettings();
            a.bc.bottomMargin = a.dr();
            a.bc.leftMargin = a.ds();
            a.bc.rightMargin = a.dt();
            a.bc.topMargin = a.du();
            a.bc.location = a.ay();
            a.bc.angle = a.dq();
            a.bc.horizontalAlignment = a.ie();
            a.bc.verticalAlignment = a.i9();
        }
        b(a.bc);
    };
    XYChart.prototype.g3 = function (a, b, c) {
        var _this = this;
        _super.prototype.g3.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.m9(function (d) { return d.angle = _this.jq; });
                break;
            case "YAxisLabelAngle":
                this.nd(function (d) { return d.angle = _this.j7; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.m9(function (d) { return d.horizontalAlignment = _this.ni; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.nd(function (d) { return d.horizontalAlignment = _this.nk; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.m9(function (d) { return d.verticalAlignment = _this.og; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.nd(function (d) { return d.verticalAlignment = _this.oh; });
                break;
            case "XAxisLabelVisibility":
                this.m9(function (d) { return d.visibility = _this.ol; });
                break;
            case "YAxisLabelVisibility":
                this.nd(function (d) { return d.visibility = _this.om; });
                break;
            case "XAxisLabel":
                this.m7(function (d) { return d.e7 = _this.kp; });
                break;
            case "YAxisLabel":
                this.nb(function (d) { return d.e7 = _this.kq; });
                break;
            case "XAxisTitleAngle":
                this.na(function (d) { return d.angle = _this.j0; });
                break;
            case "YAxisTitleAngle":
                this.ne(function (d) { return d.angle = _this.kh; });
                break;
            case "XAxisTitleAlignment":
                this.na(function (d) { return d.horizontalAlignment = _this.nj; });
                break;
            case "YAxisTitleAlignment":
                this.ne(function (d) { return d.verticalAlignment = _this.oi; });
                break;
            case "XAxisTitle":
                this.m7(function (d) { return d.f7 = _this.ln; });
                break;
            case "YAxisTitle":
                this.nc(function (d) { return d.f7 = _this.mp; }, false);
                break;
            case "XAxisMajorStroke":
                this.m8(function (d) { return d.ij = _this.n0; }, a);
                break;
            case "YAxisMajorStroke":
                this.nb(function (d) { return d.ij = _this.n7; });
                break;
            case "XAxisMajorStrokeThickness":
                this.m8(function (d) { return d.d3 = _this.jv; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.nb(function (d) { return d.d3 = _this.kc; });
                break;
            case "XAxisMinorStroke":
                this.m7(function (d) { return d.ik = _this.n1; });
                break;
            case "YAxisMinorStroke":
                this.nb(function (d) { return d.ik = _this.n8; });
                break;
            case "XAxisMinorStrokeThickness":
                this.m7(function (d) { return d.d6 = _this.jw; });
                break;
            case "YAxisMinorStrokeThickness":
                this.nb(function (d) { return d.d6 = _this.kd; });
                break;
            case "XAxisTickLength":
                this.m7(function (d) { return d.eo = _this.jy; });
                break;
            case "YAxisTickLength":
                this.nb(function (d) { return d.eo = _this.kf; });
                break;
            case "XAxisTickStroke":
                this.m7(function (d) { return d.io = _this.n4; });
                break;
            case "YAxisTickStroke":
                this.nb(function (d) { return d.io = _this.ob; });
                break;
            case "XAxisTickStrokeThickness":
                this.m7(function (d) { return d.ep = _this.jz; });
                break;
            case "YAxisTickStrokeThickness":
                this.nb(function (d) { return d.ep = _this.kg; });
                break;
            case "XAxisStroke":
                this.m7(function (d) { return d.im = _this.n3; });
                break;
            case "YAxisStroke":
                this.nb(function (d) { return d.im = _this.oa; });
                break;
            case "XAxisStrokeThickness":
                this.m7(function (d) { return d.en = _this.jx; });
                break;
            case "YAxisStrokeThickness":
                this.nb(function (d) { return d.en = _this.ke; });
                break;
            case "XAxisExtent":
                this.m9(function (d) { return d.extent = _this.jp; });
                break;
            case "YAxisExtent":
                this.nd(function (d) { return d.extent = _this.j6; });
                break;
            case "XAxisStrip":
                this.m7(function (d) { return d.il = _this.n2; });
                break;
            case "YAxisStrip":
                this.nb(function (d) { return d.il = _this.n9; });
                break;
            case "XAxisInverted":
                this.m7(function (d) { return d.b8 = _this.ik; });
                break;
            case "YAxisInverted":
                this.nb(function (d) { return d.b8 = _this.il; });
                break;
            case "YAxisLabelLocation":
                this.nd(function (d) { return d.location = _this.ih; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "kp", {
        get: function () {
            return this.kn;
        },
        set: function (a) {
            var b = this.kp;
            if (a != b) {
                this.kn = a;
                this.g3("XAxisLabel", b, this.kp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kq", {
        get: function () {
            return this.ko;
        },
        set: function (a) {
            var b = this.kq;
            if (a != b) {
                this.ko = a;
                this.g3("YAxisLabel", b, this.kq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n0", {
        get: function () {
            return this.nm;
        },
        set: function (a) {
            var b = this.n0;
            if (a != b) {
                this.nm = a;
                this.g3("XAxisMajorStroke", b, this.n0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n7", {
        get: function () {
            return this.nt;
        },
        set: function (a) {
            var b = this.n7;
            if (a != b) {
                this.nt = a;
                this.g3("YAxisMajorStroke", b, this.n7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jv", {
        get: function () {
            return this.it;
        },
        set: function (a) {
            var b = this.jv;
            if (a != b) {
                this.it = a;
                this.g3("XAxisMajorStrokeThickness", b, this.jv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kc", {
        get: function () {
            return this.ja;
        },
        set: function (a) {
            var b = this.kc;
            if (a != b) {
                this.ja = a;
                this.g3("YAxisMajorStrokeThickness", b, this.kc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jw", {
        get: function () {
            return this.iu;
        },
        set: function (a) {
            var b = this.jw;
            if (a != b) {
                this.iu = a;
                this.g3("XAxisMinorStrokeThickness", b, this.jw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kd", {
        get: function () {
            return this.jb;
        },
        set: function (a) {
            var b = this.kd;
            if (a != b) {
                this.jb = a;
                this.g3("YAxisMinorStrokeThickness", b, this.kd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n2", {
        get: function () {
            return this.no;
        },
        set: function (a) {
            var b = this.n2;
            if (a != b) {
                this.no = a;
                this.g3("XAxisStrip", b, this.n2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n9", {
        get: function () {
            return this.nv;
        },
        set: function (a) {
            var b = this.n9;
            if (a != b) {
                this.nv = a;
                this.g3("YAxisStrip", b, this.n9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n3", {
        get: function () {
            return this.np;
        },
        set: function (a) {
            var b = this.n3;
            if (a != b) {
                this.np = a;
                this.g3("XAxisStroke", b, this.n3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oa", {
        get: function () {
            return this.nw;
        },
        set: function (a) {
            var b = this.oa;
            if (a != b) {
                this.nw = a;
                this.g3("YAxisStroke", b, this.oa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jx", {
        get: function () {
            return this.iv;
        },
        set: function (a) {
            var b = this.jx;
            if (a != b) {
                this.iv = a;
                this.g3("XAxisStrokeThickness", b, this.jx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ke", {
        get: function () {
            return this.jc;
        },
        set: function (a) {
            var b = this.ke;
            if (a != b) {
                this.jc = a;
                this.g3("YAxisStrokeThickness", b, this.ke);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jy", {
        get: function () {
            return this.iw;
        },
        set: function (a) {
            var b = this.jy;
            if (a != b) {
                this.iw = a;
                this.g3("XAxisTickLength", b, this.jy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kf", {
        get: function () {
            return this.jd;
        },
        set: function (a) {
            var b = this.kf;
            if (a != b) {
                this.jd = a;
                this.g3("YAxisTickLength", b, this.kf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n4", {
        get: function () {
            return this.nq;
        },
        set: function (a) {
            var b = this.n4;
            if (a != b) {
                this.nq = a;
                this.g3("XAxisTickStroke", b, this.n4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ob", {
        get: function () {
            return this.nx;
        },
        set: function (a) {
            var b = this.ob;
            if (a != b) {
                this.nx = a;
                this.g3("YAxisTickStroke", b, this.ob);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jz", {
        get: function () {
            return this.ix;
        },
        set: function (a) {
            var b = this.jz;
            if (a != b) {
                this.ix = a;
                this.g3("XAxisTickStrokeThickness", b, this.jz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kg", {
        get: function () {
            return this.je;
        },
        set: function (a) {
            var b = this.kg;
            if (a != b) {
                this.je = a;
                this.g3("YAxisTickStrokeThickness", b, this.kg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ln", {
        get: function () {
            return this.ks;
        },
        set: function (a) {
            var b = this.ln;
            if (a != b) {
                this.ks = a;
                this.g3("XAxisTitle", b, this.ln);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mp", {
        get: function () {
            return this.kv;
        },
        set: function (a) {
            var b = this.mp;
            if (a != b) {
                this.kv = a;
                this.g3("YAxisTitle", b, this.mp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n1", {
        get: function () {
            return this.nn;
        },
        set: function (a) {
            var b = this.n1;
            if (a != b) {
                this.nn = a;
                this.g3("XAxisMinorStroke", b, this.n1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n8", {
        get: function () {
            return this.nu;
        },
        set: function (a) {
            var b = this.n8;
            if (a != b) {
                this.nu = a;
                this.g3("YAxisMinorStroke", b, this.n8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jq", {
        get: function () {
            return this.io;
        },
        set: function (a) {
            var b = this.jq;
            if (a != b) {
                this.io = a;
                this.g3("XAxisLabelAngle", b, this.jq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j7", {
        get: function () {
            return this.i5;
        },
        set: function (a) {
            var b = this.j7;
            if (a != b) {
                this.i5 = a;
                this.g3("YAxisLabelAngle", b, this.j7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jp", {
        get: function () {
            return this.im;
        },
        set: function (a) {
            var b = this.jp;
            if (a != b) {
                this.im = a;
                this.g3("XAxisExtent", b, this.jp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j6", {
        get: function () {
            return this.i4;
        },
        set: function (a) {
            var b = this.j6;
            if (a != b) {
                this.i4 = a;
                this.g3("YAxisExtent", b, this.j6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j0", {
        get: function () {
            return this.iy;
        },
        set: function (a) {
            var b = this.j0;
            if (a != b) {
                this.iy = a;
                this.g3("XAxisTitleAngle", b, this.j0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kh", {
        get: function () {
            return this.jf;
        },
        set: function (a) {
            var b = this.kh;
            if (a != b) {
                this.jf = a;
                this.g3("YAxisTitleAngle", b, this.kh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ik", {
        get: function () {
            return this.ii;
        },
        set: function (a) {
            var b = this.ik;
            if (a != b) {
                this.ii = a;
                this.g3("XAxisInverted", b, this.ik);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "il", {
        get: function () {
            return this.ij;
        },
        set: function (a) {
            var b = this.il;
            if (a != b) {
                this.ij = a;
                this.g3("YAxisInverted", b, this.il);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nj", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            var b = this.nj;
            if (a != b) {
                this.ng = a;
                this.g3("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nj));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oi", {
        get: function () {
            return this.of;
        },
        set: function (a) {
            var b = this.oi;
            if (a != b) {
                this.of = a;
                this.g3("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.oi));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ni", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            var b = this.ni;
            if (a != b) {
                this.nf = a;
                this.g3("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ni));
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.get_nk = function () {
        return this.nh;
    };
    XYChart.prototype.set_nk = function (a) {
        var b = this.nk;
        if (a != b) {
            this.nh = a;
            this.g3("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nk));
        }
    };
    Object.defineProperty(XYChart.prototype, "nk", {
        get: function () {
            return this.get_nk();
        },
        set: function (a) {
            this.set_nk(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "og", {
        get: function () {
            return this.od;
        },
        set: function (a) {
            var b = this.og;
            if (a != b) {
                this.od = a;
                this.g3("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.og));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oh", {
        get: function () {
            return this.oe;
        },
        set: function (a) {
            var b = this.oh;
            if (a != b) {
                this.oe = a;
                this.g3("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.oh));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ol", {
        get: function () {
            return this.oj;
        },
        set: function (a) {
            var b = this.ol;
            if (a != b) {
                this.oj = a;
                this.g3("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ol));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "om", {
        get: function () {
            return this.ok;
        },
        set: function (a) {
            var b = this.om;
            if (a != b) {
                this.ok = a;
                this.g3("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.om));
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.get_ih = function () {
        return this.ig;
    };
    XYChart.prototype.set_ih = function (a) {
        var b = this.ih;
        if (a != b) {
            this.ig = a;
            this.g3("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.ih));
        }
    };
    Object.defineProperty(XYChart.prototype, "ih", {
        get: function () {
            return this.get_ih();
        },
        set: function (a) {
            this.set_ih(a);
        },
        enumerable: true,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
//# sourceMappingURL=XYChart.js.map