import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core/ES5/IgCollection";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES5/SyncableObservableCollection$2";
import { FinancialOverlayType_$type } from './FinancialOverlayType';
import { ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
var FinancialOverlayTypeCollection = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialOverlayTypeCollection, _super);
    function FinancialOverlayTypeCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    FinancialOverlayTypeCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(FinancialOverlayType_$type, item);
    };
    FinancialOverlayTypeCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(FinancialOverlayType_$type, FinancialOverlayType_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return FinancialOverlayTypeCollection;
}(IgCollection));
export { FinancialOverlayTypeCollection };
//# sourceMappingURL=igx-financial-overlay-type-collection.js.map