import { PieSliceOthersContext as PieSliceOthersContext_internal } from "./PieSliceOthersContext";
/**
 * Represents the selected data contained inside the Others slice.
*/
var PieSliceOthersContext = /** @class */ (function () {
    function PieSliceOthersContext() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    PieSliceOthersContext.prototype.createImplementation = function () {
        return new PieSliceOthersContext_internal();
    };
    Object.defineProperty(PieSliceOthersContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    PieSliceOthersContext.prototype.onImplementationCreated = function () {
    };
    PieSliceOthersContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return PieSliceOthersContext;
}());
export { PieSliceOthersContext };
//# sourceMappingURL=igx-pie-slice-others-context.js.map