import { Type } from '@angular/core';
import { UnknownValuePlotting } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { IgxPolarLineSeriesBaseComponent } from "./igx-polar-line-series-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarAreaSeries } from "./PolarAreaSeries";
/**
 * Represents a IgxDataChartComponent polar area series.
*/
export declare const IgxPolarAreaSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxPolarAreaSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    protected createImplementation(): PolarAreaSeries;
    /**
                                 * @hidden
                                 */
    readonly i: PolarAreaSeries;
    constructor();
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting: UnknownValuePlotting;
}
