import { RenderRequestedEventArgs as RenderRequestedEventArgs_internal } from "./RenderRequestedEventArgs";
/**
 * EventArgs class for RenderRequested events.
*
* Use the `RenderRequested` class for RenderRequested events.
*/
export declare class RenderRequestedEventArgs {
    protected createImplementation(): RenderRequestedEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: RenderRequestedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * True if animation is requested.
    *
    * Use the `animate` property true if the animation is requested.
    *
    * ```ts
    * e.animation = true;
    * ```
    */
    animate: boolean;
}
