import { Type } from '@angular/core';
import { Style } from "igniteui-angular-core/ES5/igx-style";
import { IgxShapeSeriesBaseComponent } from "./igx-shape-series-base-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterPolylineSeries } from "./ScatterPolylineSeries";
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
export declare const IgxScatterPolylineSeriesComponent_PROVIDERS: ({
    provide: typeof IgxShapeSeriesBaseComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxScatterPolylineSeriesComponent extends IgxShapeSeriesBaseComponent {
    protected createImplementation(): ScatterPolylineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: ScatterPolylineSeries;
    constructor();
    /**
     * The default style to apply to all Shapes in the series.
    */
    shapeStyle: Style;
}
