import * as tslib_1 from "tslib";
import { SelectedItemChangedEventArgs } from "./igx-selected-item-changed-event-args";
import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Provides data for the SelectedItemChanging event.
*/
var SelectedItemChangingEventArgs = /** @class */ (function (_super) {
    tslib_1.__extends(SelectedItemChangingEventArgs, _super);
    function SelectedItemChangingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(SelectedItemChangingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectedItemChangingEventArgs.prototype, "cancel", {
        /**
         * Set this to true in order to stop the SelectedItem from changing.
        */
        get: function () {
            return this.i.cancel;
        },
        set: function (v) {
            this.i.cancel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return SelectedItemChangingEventArgs;
}(SelectedItemChangedEventArgs));
export { SelectedItemChangingEventArgs };
//# sourceMappingURL=igx-selected-item-changing-event-args.js.map